<?php

session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    echo json_encode(array("resultado" => false, "resposta" => "Sessão não encontrada"));
    exit();
}

$email = $_SESSION['email'];
$sennha = $_SESSION['senha'];

$x = $_POST['x'];
$y = $_POST['y'];
$w = $_POST['w'];
$h = $_POST['h'];
$s = $_POST['s'];
$is = $_POST['is'];
include '../config/Database.php';
include '../controladores/ControladorUsuario.php';
$controlador = new ControladorUsuario();
if (!$controlador->setUser($email)) {
    echo json_encode(array("resultado" => false, "resposta" => "Usuário desconhecido"));
    exit();
}
$imageurl = $_POST['url'];

if (!file_exists("../".$imageurl)) {
    echo json_encode(array("resultado" => false, "resposta" => "Arquivo não encontrar, tente fazer upload novamente"));
    exit();
}

$type = strtolower(pathinfo($imageurl, PATHINFO_EXTENSION));
switch ($type) {
    case 'jpeg':
    case 'jpg':
        $resource = imagecreatefromjpeg("../" . $imageurl);
        break;

    case 'png':
        $resource = imagecreatefrompng("../" . $imageurl);
        break;

    case 'gif':
        $resource = imagecreatefromgif("../" . $imageurl);
        break;

    default:
        $resource = false;
        break;
}

if ($resource != false) {
    $oldw = imagesx($resource);
    $oldh = imagesy($resource);

    if ($oldh > $oldw) {
        $s = ((($s / $is) * 500) / $oldw);
    } else {
        $s = ((($s / $is) * 500) / $oldh);
    }


    $result = imagecreatetruecolor($s * $oldw, $s * $oldh);
    imagecopyresampled($result, $resource, 0, 0, 0, 0, $s * $oldw, $s * $oldh, $oldw, $oldh);

    $result = imagecrop($result, array("x" => $x, "y" => $y, "width" => $w, "height" => $h));

    $filePath = $controlador->getUserId() . '.png';
    $destino = 'users/image/' . $filePath;

    imagepng($result,"../" . $destino);
    echo json_encode(["resultado" => true, "url" => $destino]);
} else {
    echo json_encode(["resultado" => false, "resposta" => "verifique-se o arquivo informado termina com .png,.jpg,.jpeg,.gif\n talvez não seja um tipo de arquivo válido"]);
}
    


