<?php

    session_start();
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        echo 'Erro: sessão fechada';
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';
    include './controladores/Turma.php';
    include './entidades/MaterialDidatico.php';
    $email = $_SESSION['email'];
    
    $controlador = new ControladorUsuario();
    
    $controlador->setUser($email);
    
    if(!isset($_POST['id']))
    {
        echo 'Parametros faltando:';
        $a = $_POST['id'];
        return;
    }
    
    $id = (int)$_POST['id'];
    
    if($controlador->ehAluno())
    {
        include './controladores/Aluno.php';
        $aluno = $controlador->getAluno();
        $turma = $aluno->getTurma();
        $material = $turma->getMaterial($id);
        if((int)$turma->getIdturma()===(int)$material->getIdturma())
        {
            download($material);
        }
    }
    else{
        
        if(!isset($_POST['index']))
        {
            echo 'Parametros faltando:';
            $a = $_POST['index'];
            return;
        }
        
        $index = (int)$_POST['index'];
        
        include './controladores/Professor.php';
        $professor = $controlador->getProfessor();
        $turma = $professor->getTurmaByIndex($index);
        $material = $turma->getMaterial($id);
        if((int)$turma->getIdturma()===(int)$material->getIdturma())
        {
            download($material);
        }
    }

    
    function download($material)
    {
        set_time_limit(0);

        if (!file_exists($material->getCaminho())) {
            exit;
        }

        header('Content-Description: File Transfer');
        header('Content-Disposition: attachment; filename="'.$material->getNome().'"');
        header('Content-Type: application/octet-stream');
        header('Content-Transfer-Encoding: binary');
        header('Content-Length: ' . filesize($material->getCaminho()));
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Pragma: public');
        header('Expires: 0');
        // Envia o arquivo para o cliente
        readfile($material->getCaminho());
    }