<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Insere(No,Pai,Info)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l0" class="handlerTab">Se No == nulo então</p>
    <div class="TabCode">
        <p id="l1">INICIO</p>
        <p id="l2">&nbsp; No := alocar();</p>
        <p id="l3">&nbsp; No.Info := Info;</p>
        <p id="l4">FIM</p>
    </div>
    <br>
    <p id="l5" class="handlerTab">Senão Se No.Info < Info então</p>
    <div class="TabCode">
        <p id="l6">INICIO</p>
        <br>
        <p id="l7">&nbsp; Insere(No.Direita,No,Info);</p>
        <br>
        <p id="l8" class="handlerTab">&nbsp; Se Abs(FatorBalanceamento(No) ) >= 2 então</p>
        <div class="TabCode">
            <p id="l9">&nbsp; Verifica(Pai,No);</p>
        </div>
        <br>
        <p id="l10">FIM</p>
    </div>
    <br>
    <p id="l11" class="handlerTab">Senão Se No.Info > Info então</p>
    <div class="TabCode">
        <p id="l12">INICIO</p>
        <br>
        <p id="l13">&nbsp; Insere(No.Esquerda,No,Info);</p>
        <br>
        <p id="l14" class="handlerTab">&nbsp; Se Abs(FatorBalanceamento(No) ) >= 2 então</p>
        <div class="TabCode">
            <p id="l15">&nbsp; Verifica(Pai,No);</p>
        </div>
        <br>
        <p id="l16">FIM</p>
    </div>
</div>
<div class="Separator"></div>
    <div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>FatorBalanceamento(No)</div>
    <div class="subhead-item"><font style="font-size:18px;">RETORNA</font><br>O nível de balanceamento da árvore</div>
<div class="Separator"></div>
<div class="code">
    <p id="l17">Retornar Altura(No.Direita) - Altura(No.Esquerda);</p>
</div>
<div class="Separator"></div>
    <div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Altura(No)</div>
    <div class="subhead-item"><font style="font-size:18px;">RETORNA</font><br>A altura a partir do No</div>
<div class="Separator"></div>
<div class="code">
    <p id="l18" class="handlerTab">Se No == nulo então</p>
    <div class="TabCode">
        <p id="l19">&nbsp; Retornar -1;</p>
    </div>
    <br>
    <p id="l20">Retornar Max(Altura(No.Esquerda) + 1 ,Altura(No.Direita) + 1 )</p>
</div>
<div class="Separator"></div>
    <div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Verifica(Pai,No)</div>
    <div class="subhead-item"><font style="font-size:18px;">RETORNA</font><br>Verifica qual será a Rotação na árvore</div>
<div class="Separator"></div>
<div class="code">
    <p id="l21">fb : Inteiro;</p>
    <p id="l22">fb := FatorBalanceamento(No);</p>
    <br>
    <p id="l23" class="handlerTab">Se fb > 0 então</p>
    <div class="TabCode">
        <p id="l24">INICIO</p>
        <p id="l25" class="handlerTab">&nbsp; Se FatorBalanceamento(No.Direita) > 0 então</p>
        <div class="TabCode">
            <p id="l26">&nbsp; RotaçãoEsquerda(Pai,No);</p>
        </div>
        <p id="l27" class="handlerTab">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l28">INICIO</p>
            <p id="l29">&nbsp; RotaçãoDireita(No,No.Direita);</p>
            <p id="l30">&nbsp; RotaçãoEsquerda(Pai,No);</p>
            <p id="l31">FIM</p>
        </div>
        <p id="l32">FIM</p>
    </div>
    <p id="l33" class="handlerTab">Senão</p>
    <div class="TabCode">
        <p id="l34">INICIO</p>
        <p id="l35" class="handlerTab">&nbsp; Se FatorBalanceamento(No.Esquerda) < 0 então</p>
        <div class="TabCode">
            <p id="l36">&nbsp; RotaçãoDireita(Pai,No);</p>
        </div>
        <p id="l37" class="handlerTab">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l38">INICIO</p>
            <p id="l39">&nbsp; RotaçãoEsquerda(No,No.Esquerda);</p>
            <p id="l40">&nbsp; RotaçãoDireita(Pai,No);</p>
            <p id="l41">FIM</p>
        </div>
        <p id="l42">FIM</p>
    </div>
</div>
<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>RotaçãoEsquerda(Pai,No)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l43">q : EstruturaAVL;</p>
    <p id="l44">temp : EstruturaAVL;</p>
    <p id="l45">q := No.Direita;</p>
    <p id="l46">temp := q.Esquerda;</p>
    <br>
    <p id="l47">q.Esquerda = No;</p>
    <p id="l48">No.Direita = temp;</p>
    <br>
    <p id="l49" class="handlerTab">Se Pai != nulo então</p>
    <div class="TabCode">
        <p id="l50">INICIO</p>
        <p id="l51" class="handlerTab">&nbsp; Se Pai.Direita == No então</p>
        <div class="TabCode">
            <p id="l52">&nbsp; Pai.Direita := q;</p>
        </div>
        <p id="l53" class="handlerTab">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l54">&nbsp; Pai.Esquerda := q;</p>
        </div>
        <p id="l55">FIM</p>
    </div>
    <p id="l56" class="handlerTab">Senão</p>
    <div class="TabCode">
        <p id="l57">&nbsp; No := q;</p>
    </div>
    <br>
</div>
<div class="Separator"></div>
    <div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>RotaçãoDireita(Pai,No)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l58">q : EstruturaAVL;</p>
    <p id="l59">temp : EstruturaAVL;</p>
    <p id="l60">q := No.Esquerda;</p>
    <p id="l61">temp := q.Direita;</p>
    <br>
    <p id="l62">q.Direita := No;</p>
    <p id="l63">No.Esquerda := temp;</p>
    <br>
    <p id="l64" class="handlerTab">Se Pai != nulo então</p>
    <div class="TabCode">
        <p id="l65">INICIO</p>
            <p id="l66" class="handlerTab">&nbsp; Se Pai.Direita == No então</p>
            <div class="TabCode">
                <p id="l67">&nbsp; Pai.Direita := q;</p>
            </div>
            <p id="l68" class="handlerTab">&nbsp; Senão</p>
            <div class="TabCode">
                <p id="l69">&nbsp; Pai.Esquerda := q;</p>
            </div>
        <p id="l70">FIM</p>
    </div>
    <p id="l71" class="handlerTab">Senão</p>
    <div class="TabCode">
        <p id="l72">&nbsp; No := q;</p>
    </div>
</div>