<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Insere ou Enqueue(INFO,PRIORIODADE)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l0" title="Declarando novo elemento e cursores">novo,leitor,anterior : EstruturaFila;</p>
    <p id="l1" title="Alocando o novo elemento">novo := alocar();</p>
    <p id="l2" title="Definindo valor do elemento">novo.info := INFO;</p>
    <p id="l3" title="Definindo a prioridade do elemento">novo.prioridade := PRIORIDADE;</p>
    <p id="l4" title="Cursor 'leitor' aponta para o inicio da fila">leitor := Fila.inicio;</p>
    <br>
    <p id="l5" class="handlerTab" title="Percorrendo elementos da fila para buscar a posição correta">Enquanto leitor != nulo e leitor.prioridade < PRIORIDADE então</p>
    <div class="TabCode">
        <p id="l6">INICIO</p>
        <p id="l7" title="Cursor 'anterior' aponta para o atual elemento da leitura">&nbsp; anterior := leitor;</p>
        <p id="l8" title="Cursor 'leitor' aponta para o próximo elemento da leitura">&nbsp; leitor := leitor.proximo;</p>
        <p id="l9">FIM</p>
    </div>
    <br>
    <p id="l10" class="handlerTab" title="Inserindo numa posição diferente da última">Se leitor != nulo então</p>
    <div class="TabCode">
        <p id="l11">INICIO</p>
        <p id="l12" class="handlerTab" title="Inserindo na primeira posição">&nbsp; Se anterior == nulo então</p>
        <div class="TabCode">
            <p id="l13">INICIO</p>
            <p id="l14">&nbsp; novo.proximo := Fila.inicio;</p>
            <p id="l15">&nbsp; Fila.inicio.anterior := novo;</p>
            <p id="l16">&nbsp; Fila.inicio := novo;</p>
            <p id="l17">FIM</p>
        </div>
        <p id="l18" class="handlerTab" title="Inserindo em posição intermediária">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l19">INICIO</p>
            <p id="l20">&nbsp; novo.proximo := leitor;</p>
            <p id="l21">&nbsp; novo.anterior := anterior;</p>
            <p id="l22">&nbsp; anterior.proximo := novo;</p>
            <p id="l23">&nbsp; leitor.anterior := novo;</p>
            <p id="l24">FIM</p>
        </div>
        <p id="l25">FIM</p>
    </div>
    <p id="l26" class="handlerTab">Senão</p>
    <div class="TabCode">
        <p id="l27">INICIO</p>
        <p id="l28" class="handlerTab" title="Inserindo o primeiro elemento">&nbsp; Se anterior == nulo então</p>
        <div class="TabCode">
            <p id="l29" title="Novo primeiro elemento da fila">&nbsp; Fila.inicio := novo;</p>
        </div>
        <p id="l30" class="handlerTab" title="Inserindo na última posição">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l31">INICIO</p>
            <p id="l32">&nbsp; Fila.fim.proximo := novo;</p>
            <p id="l33">&nbsp; novo.anterior := Fila.fim;</p>
            <p id="l34">FIM</p>
        </div>
        <p id="l35">&nbsp; Fila.fim := novo;</p>
        <p id="l36">FIM</p>
    </div>
</div>