<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Insere(INFO)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l0" title="Declarando índice para armazenar resultado da função HASH">indice : inteiro;</p>
    <p id="l1" title="Calculando a função HASH">indice := Hash(INFO);</p>
    <p id="l2" title="Declarando o novo elemento">novo : EstruturaLista;</p>
    <p id="l3" title="Alocando o novo elemento">novo := alocar();</p>
    <p id="l4" title="Definindo valor do novo elemento">novo.info := INFO;</p>
    <br>
    <p id="l5" class="handlerTab" title="Verificando se a lista está vazia">Se TabelaHash[indice] == nulo então</p>
    <div class="TabCode">
        <p id="l6" title="Lista recebe novo elemento">&nbsp; TabelaHash[indice] := novo;</p>
    </div>
    <p id="l7" class="handlerTab" title="Caso a lista não estiver vazia">Senão</p>
    <div class="TabCode">
        <p id="l8">INICIO</p>
        <p id="l9" title="Declarando cursores para leitura">&nbsp; leitor,anterior : EstruturaLista;</p>
        <p id="l10" title="Posicionando cursor 'leitor' no início da lista">&nbsp; leitor := TabelaHash[indice];</p>
        <br>
        <p id="l11" class="handlerTab" title='Percorrendo elementos da lista com valores menores ao pesquisado'>&nbsp; Enquanto leitor != nulo e leitor.info <= INFO faça</p>
        <div class="TabCode">
            <p id="l12">INICIO</p>
            <p id="l13" title="Cursor 'anterior' aponta para o atual elemento da leitura">&nbsp; anterior := leitor;</p>
            <p id="l14" title="Cursor 'leitor' aponta para o próximo elemento da leitura">&nbsp; leitor := leitor.proximo;</p>
            <p id="l15">FIM</p>
        </div>
        <br>
        <p id="l16" class="handlerTab" title="Inserindo numa posição diferente da última">&nbsp; Se leitor != nulo então</p>
        <div class="TabCode">
            <p id="l17">INICIO</p>
            <p id="l18" class="handlerTab" title="Inserindo em posição intermediária">&nbsp; Se anterior != nulo então</p>
            <div class="TabCode">
                <p id="l19">INICIO</p>
                <p id="l20">&nbsp; novo.proximo := leitor;</p>
                <p id="l21">&nbsp; novo.anterior  := anterior;</p>
                <p id="l22">&nbsp; anterior.proximo := novo;</p>
                <p id="l23">&nbsp; leitor.anterior := novo;</p>
                <p id="l24">FIM</p>
            </div>
            <p id="l25" class="handlerTab" title="Inserindo na primeira posição">&nbsp; Senão</p>
            <div class="TabCode">
                <p id="l26">INICIO</p>
                <p id="l27">&nbsp; novo.proximo := TabelaHash[indice];</p>
                <p id="l28">&nbsp; TabelaHash[indice].anterior := novo;</p>
                <p id="l29">&nbsp; TabelaHash[indice] := novo;</p>
                <p id="l30">FIM</p>
            </div>
            <p id="l31">FIM</p>
        </div>
        <p id="l32" class="handlerTab" title="Inserindo na última posição">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l33">INICIO</p>
            <p id="l34">&nbsp; anterior.proximo := novo;</p>
            <p id="l35">&nbsp; novo.anterior := anterior;</p>
            <p id="l36">FIM</p>
        </div>
        <p id="l37">FIM</p>
    </div>
</div>
<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Hash(INFO)</div>
<div class="subhead-item"><font style="font-size:18px;">RETORNA</font><br>O índice do respectivo valor</div>
<div class="Separator"></div>
<div class="code">
    <p id="l38" title="Declarando variáveis">soma,total : inteiro;</p>
    <p id="l39" title="Inicializando a soma">soma := 0;</p>
    <p id="l40" title="total recebe o tamanho da palavra">total := INFO.comprimento;</p>
    <br>
    <p id="l41" class="handlerTab" title="Percorrendo cada letra da palavra">Para i de 0 até total passo 1 faça</p>
    <div class="TabCode">
        <p id="l42" title="Info.caracter retorna a posição (do tipo inteiro) na tabela ASCII">&nbsp; soma := soma + (i+1)*INFO.caracter(i);</p>
    </div>
    <br>
    <p id="l43" title="Recuperando resto da divisão, limitando o resultado entre 0 e o tamanho total da tabela Hash">soma := soma % TAMANHO_DA_TABELA;</p>
    <p id="l44" title="Retornando um valor entre 0 e o tamanho total da tabela Hash correspondente a entrada">Retornar soma;</p>
</div>