<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Insere(No,Palavra)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l0" class="handlerTab" title="Se a Lista não estiver completa">Se tamanho != MAXIMO então </p>
    <div class="TabCode">
        <p id="l1">INICIO</p>
        <p id="l2" title="Definindo o valor do novo elemento no indice disponível">&nbsp; lista[indice].info := INFO;</p>
        <p id="l3" title="Declarando variável auxiliar">&nbsp; auxiliar : inteiro;</p>
        <p id="l4" title="O ponteiro 'auxiliar' aponta para o proximo elemento do indice disponível">&nbsp; auxiliar := lista[indice].proximo;</p>
        <p id="l5" title="O ponteiro 'próximo' do indice disponível aponta para vazio">&nbsp; lista[indice].proximo := -1;</p>
        <br>
        <p id="l6" class="handlerTab" title="Se o novo elemento não for o único da lista">&nbsp; Se primeiroIndice != -1 então</p>
        <div class="TabCode">
            <p id="l7">INICIO</p>
            <p id="l8" title="Declarando variáveis para percorrer a lista">&nbsp; anterior,i : Inteiro;</p>
            <p id="l9" title="Anterior aponta pra vazio">&nbsp; anterior := -1;</p>
            <p id="l10" title="A variável de leitura aponta para o primeiro elemento da lista">&nbsp; i := primeiroIndice;</p>
            <br>  
            <p id="l11" class="handlerTab" title="Percorrendo a lista, enquanto o valor do elemento percorrido for menor do que aquele a ser inserido">&nbsp; Enquanto i != -1 e lista[i] < INFO então</p>
            <div class="TabCode">
                <p id="l12">INICIO</p>
                <p id="l13" title="Anterior aponta para o elemento atual a ser percorrido">&nbsp; anterior := i;</p>
                <p id="l14" title="Variável de leitura aponta para o próximo elemento da lista">&nbsp; i := lista[i].proximoElemento;</p>
                <p id="l15">FIM</p>
            </div>
            <p id="l16" class="handlerTab" title="Se for inserido como primeiro elemento da lista">&nbsp; Se anterior != -1 então </p>
            <div class="TabCode">
                <p id="l17">INICIO</p>
                <p id="l18" title="Proximo elemento do 'indice disponivel' aponta para o 'primeiro indice'">&nbsp; lista[indice].prox := primeiroIndice;</p>
                <p id="l19" title="'Primeiro indice' aponta agora para o 'indice disponivel', tornando o novo elemento o primeiro da lista">&nbsp; primeiroIndice := indice;</p>
                <p id="l20">FIM</p>
            </div>
            <p id="l21" class="handlerTab" title='Caso o novo elemento não for o primeiro da lista'>&nbsp; Senão</p>
            <div class="TabCode">
                <p id="l22">INICIO</p>
                <p id="l23" class="handlerTab" title="Se for diferente do última posição">&nbsp; Se i != -1 então</p>
                <div class="TabCode">
                    <p id="l24" title="Próximo elemento do 'indice disponivel' aponta para o proximo elemento do 'anterior'">&nbsp; lista[indice].proximo := lista[anterior].proximo;</p>
                </div>
                <p id="l25" title="Próximo elemento do 'anterior' aponta para o indice disponivel">&nbsp; lista[anterior].proximo := indice;</p>
                <p id="l26">FIM</p>
            </div>
            <p id="l27">FIM</p>
        </div>
        <p id="l28" class="handlerTab" title="Caso contrário, se o novo elemento for o único da lista">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l29" title="Primeiro indice aponta para o novo elemento">&nbsp; primeiroIndice := indice;</p>
        </div>
        <p id="l30" title="Próximo elemento disponível aponta para o próximo">&nbsp; indice := auxiliar;</p>
        <p id="l31">FIM</p>
    </div>
</div>