<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Remove(TrieNo,AntNo,OriNo,Palavra,i,size)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l0" class="handlerTab">Se TrieNo != nulo então</p>
    <div class="TabCode">
        <p id="l1">INICIO</p>
        <p id="l2" class="handlerTab">&nbsp; Se TrieNo.Info == Palavra[i] então</p>
        <div class="TabCode">
            <p id="l3">INICIO</p>
            <p id="l4" class="handlerTab">&nbsp; Se i==size-1 então</p>
            <div class="TabCode">
                <p id="l5">INICIO</p>
                <p id="l6" class="handlerTab">&nbsp; Se TrieNo.UltimoChar == Verdadeiro então</p>
                <div class="TabCode">
                    <p id="l7">INICIO</p>
                    <p id="l8" class="handlerTab">&nbsp; Se AntNo != nulo então</p>
                    <div class="TabCode">
                        <p id="l9">INICIO</p>
                        <p id="l10" class="handlerTab">&nbsp; Se AntNo.UltimoChar == Verdadeiro então</p>
                        <div class="TabCode">
                            <p id="l11">&nbsp; RemoverSegmento(AntNo.Abaixo);</p>
                        </div>
                        <p id="l12" class="handlerTab">&nbsp; Senão se AntNo.Proximo != nulo então</p>
                        <div class="TabCode">
                            <p id="l13">INICIO</p>
                            <p id="l14">&nbsp; Proximo, Abaixo : EstruturaTrie;</p>
                            <p id="l15">&nbsp; Abaixo := TrieNo.Abaixo;</p>
                            <p id="l16">&nbsp; Proximo := TrieNo.Proximo;</p>
                            <p id="l17">&nbsp; Liberar(TrieNo);</p>
                            <p id="l18">&nbsp; TrieNo := Proximo;</p>
                            <p id="l19">&nbsp; RemoverSegmento(Abaixo);</p>
                            <p id="l20">&nbsp; FIM</p>
                        </div>
                        <p id="l21" class="handlerTab">&nbsp; Senão</p>
                        <div class="TabCode">
                            <p id="l22">RemoverSegmento(AntNo);</p>
                        </div>
                        <p id="l23">FIM</p>
                    </div>
                    <p id="l24" class="handlerTab">&nbsp; Senão</p>
                    <div class="TabCode">
                        <p id="l25">INICIO</p>
                        <p id="l26" class="handlerTab">&nbsp; Se TrieNo.Abaixo == nulo então</p>
                        <div class="TabCode">
                            <p id="l27">INICIO</p>
                            <p id="l28" class="handlerTab">&nbsp; Se TrieNo.Proximo == nulo então</p>
                            <div class="TabCode">
                                <p id="l29">&nbsp; RemoverSegmento(OriNo);</p>
                            </div>
                            <p id="l30" class="handlerTab">&nbsp; Senão</p>
                            <div class="TabCode">
                                <p id="l31">INICIO</p>
                                <p id="l32">&nbsp; Proximo : EstruturaTrie;</p>
                                <p id="l33">&nbsp; Proximo := TrieNo.Proximo;</p>
                                <p id="l34">&nbsp; Liberar(TrieNo);</p>
                                <p id="l35">&nbsp; TrieNo := Proximo;</p>
                                <p id="l36">FIM</p>
                            </div>
                            <p id="l37">FIM</p>
                        </div>
                        <p id="l38" class="handlerTab">&nbsp; Senão</p>
                        <div class="TabCode">
                            <p id="l39">&nbsp; TrieNo.UltimoChar := Falso;</p>
                        </div>
                        <p id="l40">FIM</p>
                    </div>
                    <p id="l41">FIM</p>
                </div>
                <p id="l42" class="handlerTab">&nbsp; Senão</p>
                <div class="TabCode">
                    <p id="l43">&nbsp; return;</p>
                </div>
                <p id="l44">FIM</p>
            </div>
            <p id="l45" class="handlerTab">&nbsp; Senão</p>
            <div class="TabCode">
                <p id="l46">INICIO</p>
                <p id="l47" class="handlerTab">&nbsp; Se TrieNo.Proximo != nulo ou TrieNo.UltimoChar == Verdadeiro então</p>
                <div class="TabCode">
                    <p id="l48">&nbsp; Retornar Remove(TrieNo.Abaixo,TrieNo,OriNo,Palavra,i+1,size);</p>
                </div>
                <p id="l49" class="handlerTab">&nbsp; Senão</p>
                <div class="TabCode">
                    <p id="l50">&nbsp; Retornar Remove(TrieNo.Proximo,AntNo,Ori,Palavra,i,size);</p>
                </div>
                <p id="l51">FIM</p>
            </div>
            <p id="l52">FIM</p>
        </div>
        <p id="l53" class="handlerTab">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l54">&nbsp; Remove(TrieNo.Proximo,TrieNo.Proximo,OriNo,Palavra,i,size);</p>
        </div>
        <p id="l55">FIM</p>
    </div>
</div>
<div class="Separator"></div>
<div class="head-line">
    <font style="font-size:18px;">FUNÇÃO</font><br>
    RemoverSegmento(TrieNo)
</div>
<div class="subhead-item">
    <font style="font-size:18px;">DETALHES</font><br>
    Remove uma ramificação
</div>
<div class="Separator"></div>
<div class="code">
    <p id="l57">Abaixo : EstruturaTrie;</p>
    <br>
    <p id="l58" class="handlerTab">Enquanto TrieNo!=nulo então</p>
    <div class="TabCode">
        <p id="l59">INICIO</p>
        <p id="l60">&nbsp; Abaixo :=  TrieNo.Abaixo;</p>
        <p id="l61">&nbsp; Liberar(TrieNo);</p>
        <p id="l62">&nbsp; TrieNo := Abaixo;</p>
        <p id="l63">FIM</p>
    </div>
</div>