jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function BST() {
    this.raiz = null; //Variaveis Globais
    this.MENOR = null;
    this.MAIOR = null;
    this.size = null;

    BST.criaNo = function () { //Cria um novo No -- Objeto Definido
        return {ref: null, id: null, value: null, esq: null, dir: null};
    };

    BST.criaRef = function () { //Cria Referencia Nula
        return {ref: null};
    };


    this.inicia = function () {  //Iniciando a arvore
        this.raiz = BST.criaRef();
        this.raiz.ref = BST.criaNo(); //Raiz.ref guarda O Objeto, Raiz.ref.ref guarda sua referencia
        this.size = 0;
    };

    this.insere2 = function (raiz, elem) { //Insercao

        if (raiz.ref.ref == null) {	//Insercao 
            if (this.MENOR == null && this.MAIOR == null) {
                this.MENOR = elem.valor;
                this.MAIOR = elem.valor; //Caso Referencia for Nula, MAIOR E MENOR RECEBEM o elemento
            } else {
                if (parseInt(this.MENOR) > parseInt(elem.valor))
                    this.MENOR = elem.valor;	//Caso Esquerda
                if (parseInt(this.MAIOR) < parseInt(elem.valor))
                    this.MAIOR = elem.valor;	//Caso Direita
            }
            var noEsq = BST.criaRef();
            var noDir = BST.criaRef();
            noEsq.ref = BST.criaNo();
            noDir.ref = BST.criaNo();
            raiz.ref.d = elem.d;
            raiz.ref.ref = elem.id; //Raiz recebe o endereco de elem
            raiz.ref.id = elem.id;	//Id do Objeto recebe o elem
            raiz.ref.value = elem.valor;
            raiz.ref.esq = noEsq;
            raiz.ref.dir = noDir;
            Element.bind(raiz.ref,raiz.ref.id);
            this.size++;
        } else if (parseInt(raiz.ref.value) < parseInt(elem.valor)) {
            this.insere2(raiz.ref.dir, elem); //Insercao a direita

        } else if (parseInt(raiz.ref.value) > parseInt(elem.valor)) {
            this.insere2(raiz.ref.esq, elem); //Insercao a esquerda
        }
    };

    this.length = function () {
        return this.size;
    };

    this.insere = function (elem) {
        this.insere2(this.raiz, elem);
    };

    this.search2 = function (raiz, value) {
        if (raiz.ref.ref == null)
            return null;
        if (parseInt(raiz.ref.value) == parseInt(value))
            return raiz;
        else if (parseInt(raiz.ref.value) < parseInt(value))
            return this.search2(raiz.ref.dir, value);
        else if (parseInt(raiz.ref.value) > parseInt(value))
            return this.search2(raiz.ref.esq, value);
    };

    this.search = function (value) {
        return this.search2(this.raiz, value);
    };

    this.remocao2 = function (raiz, value) {
        if (raiz.ref.ref != null) {

            if (parseInt(raiz.ref.value) < parseInt(value))
                this.remocao2(raiz.ref.dir, value);

            else if (raiz.ref.value > value)
                this.remocao2(raiz.ref.esq, value);

            else {

                if (raiz.ref.dir.ref.ref == null)
                    raiz.ref = raiz.ref.esq.ref;
                else if (raiz.ref.esq.ref.ref == null)
                    raiz.ref = raiz.ref.dir.ref;
                else
                    this.removeSucessor(raiz, raiz.ref.dir);
            }
        }
    };

    this.removeSucessor = function (q, p) {
        if (p.ref.esq.ref.ref == null) {
            q.ref.value = p.ref.value;
            q.ref.ref = p.ref.ref;

            p.ref = p.ref.dir.ref;
        } else
            this.removeSucessor(q, p.ref.esq);
    };
    
    this.maisEsquerdo = function (raiz) {
        if (raiz.ref.esq.ref.ref == null) {
            return raiz;
        } else
            return this.maisEsquerdo(raiz.ref.esq);
    };

    this.getSucessor = function (raiz) {
        return this.maisEsquerdo(raiz.ref.dir);
    };

    this.remove = function (value) {
        this.remocao2(this.raiz, value);
    };

    this.show = function (raiz) {
        if (raiz.ref.ref != null) {
            this.show(raiz.ref.esq);
            alert(raiz.ref.value);
            this.show(raiz.ref.dir);
        }
    };
}


(function () {
    var collection = new BST();

    var
    organizarTudo = function (time){
        
        var width = parseInt($("#main").width());
        var offsetTop = 125;
        var offsetY = 75;
        var no = collection.raiz;
        var passos = [];
        var maxlvl = 0;
        var inundarlvl = function(raiz,lvl){
            if(raiz.ref.ref!==null) {
                if(raiz.ref.esq.ref.ref!==null) {
                    inundarlvl(raiz.ref.esq,lvl+1);
                } 
                if(maxlvl<lvl)
                    maxlvl = lvl;
                if(raiz.ref.dir.ref.ref!==null) {
                    inundarlvl(raiz.ref.dir,lvl+1);
                }
            }
        };
        inundarlvl(no,0);
        width = Math.max(Math.pow(2,maxlvl)*40,width);
        
        var inundar = function(raiz,lvl){
            if(raiz.ref.ref!==null){
                if(raiz.ref.esq.ref.ref!==null) {
                    passos[lvl] = 0;
                    inundar(raiz.ref.esq,lvl+1);
                }
                var maxchunks = Math.pow(2,lvl);
                var sizechunk = width / maxchunks;

                var top = offsetTop+offsetY*lvl;
                var pos = 0;
                for (var i = 0; i < lvl; i++) {
                    pos+=passos[i]*Math.pow(2,lvl-i-1);
                }
                
                var left = sizechunk*pos+(sizechunk/2-20);

                Plumb.moveTo(raiz.ref.id,left,top,time);
                
                if(raiz.ref.dir.ref.ref!==null) {
                    passos[lvl] = 1;
                    inundar(raiz.ref.dir,lvl+1);
                }
            }
        };
        inundar(no,0);
    };
    getParent = function (raiz, elem) {
        if (parseInt(raiz.ref.value) == parseInt(elem.ref.value))
            return null;

        var temp = raiz;
        while (temp.ref.ref != null && temp.ref.dir != elem && temp.ref.esq != elem) {
            if (parseInt(elem.ref.value) < parseInt(temp.ref.value))
                temp = temp.ref.esq;
            else
                temp = temp.ref.dir;
        }

        if (temp.ref.ref == null)
            return null;

        return temp;
    },
    animationAdd = function (info) {
        UI.lock();
        var pai = null;
        var raiz = collection.raiz;
        var pos = {left: 3*window.innerWidth / 8, top: 75};
        var i = 0;
        var j = 0;
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        while (raiz.ref.ref != null) 
        {
            highlighter.clear(2000*i);
            highlighter.line(0,10+2000*i);
            pos = {left: parseInt(raiz.ref.d.style.left), top: parseInt(raiz.ref.d.style.top)};
            Plumb.moveTo(info.id,pos.left,pos.top + 40,2000 * speed);

            pai = raiz;

            if (parseInt(info.valor) < parseInt(raiz.ref.value)) {
                raiz = raiz.ref.esq;
                highlighter.line(2,600+2000*i);
                highlighter.clear(1100+2000*i);
                highlighter.lineGreen(3,1200+2000*i);
            } else if (parseInt(info.valor) > parseInt(raiz.ref.value)) {
                raiz = raiz.ref.dir;
                highlighter.lineRed(2,500+2000*i);
                highlighter.line(4,1000+2000*i);
                highlighter.clear(1400+2000*i);
                highlighter.lineGreen(5,1500+2000*i);
            } else {
                highlighter.line(6,599+2000*i);
                highlighter.lineRed(2,600+2000*i);
                highlighter.lineRed(4,600+2000*i);
                highlighter.line(7,1200+2000*i);
                highlighter.clear(2000+2000*i);
                setTimeout(function(){
                    $("#"+info.id).fadeOut(2000*speed,function(){
                        UI.unlock();
                        setTimeout(function(){
                            $("#"+info.id).remove();
                            window.Eprogramada.nextQueue();
                        },2000*speed);
                    });
                },(2000*i+2000)*speed);
                return;
            }
            i++;
            j++;
        }

        highlighter.clear(2000*i);
        highlighter.lineRed(0,500+2000*i);
        highlighter.line(9,1000+2000*i);
        highlighter.line(11,1500+2000*i);
        highlighter.line(12,2000*(i+1));
        highlighter.clear(2000*(i+1)+1000);
        setTimeout(function(){
            if (pai != null) {
                connectDisc(pai, info);
            }
            collection.insere(info);
            organizarTudo(2000*speed);
            setTimeout(function(){
                window.Eprogramada.nextQueue();
                UI.unlock();
            },2000*speed);
        }, i * 2000 * speed);
  
    },
    animationSearch = function (info) {
        UI.lock();
        var raiz = collection.raiz;
        var pos = {left: window.innerWidth / 2, top: 75};
        var j = 0;
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        while (raiz.ref.ref != null) {
            var atual = 2000*j;
            highlighter.clear(atual);
            highlighter.line(0,10+atual);
            pos = {left: parseInt(raiz.ref.d.style.left), top: parseInt(raiz.ref.d.style.top)};
            Plumb.moveTo(info.id,pos.left,pos.top+40,2000*speed);

            if (parseInt(info.valor) < parseInt(raiz.ref.value)) {
                highlighter.line(2,600+atual);
                highlighter.clear(1200+atual);
                highlighter.lineGreen(3,1200+atual);
                raiz = raiz.ref.esq;
            } else if (parseInt(info.valor) > parseInt(raiz.ref.value)) {
                raiz = raiz.ref.dir;
                highlighter.line(4,500+atual);
                highlighter.lineRed(2,500+atual);
                highlighter.clear(1000+atual);
                highlighter.lineGreen(5,1000+atual);
            } else {
                highlighter.line(6,500+atual);
                highlighter.lineRed(2,500+atual);
                highlighter.lineRed(4,500+atual);
                highlighter.line(7,1000+atual);
                highlighter.clear(2000+atual);
                break;
            }
            j++;

        }
        if(raiz.ref.ref == null)
        {
            var atual = 2000*j;
            highlighter.clear(atual);
            highlighter.line(9,500+atual);
            highlighter.lineRed(0,500+atual);
            highlighter.line(10,1000+atual);
            highlighter.clear(2000+atual);
        }
        setTimeout(function () {
            $("#" + info.id).fadeOut(1000 * speed);
            if (raiz.ref.ref != null) {
                var obj = $("#" + raiz.ref.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
            }

            setTimeout(function () {
                $("#" + info.id).remove();
                UI.unlock();
            }, 1200 * speed);
        }, j * 2000 * speed + 1000 * speed);

    },
    animationRemove = function (info) {
        UI.lock();
        var speed = getSpeed();
        var value = info.valor;
        var raiz = collection.raiz;
        var highlighter = new HighlighterAlgoritmo(VK.REMOCAO);
        var pos = {left: window.innerWidth / 2, top: 75};
        var j = 0;

        while (raiz.ref.ref != null) {
            try{
                pos = {left: parseInt(raiz.ref.d.style.left), top: parseInt(raiz.ref.d.style.top)};
                Plumb.moveTo(info.id, pos.left, pos.top+40, 2000 * speed);
            }catch (err){
                alert("Error: Objeto não removido totalmente -> "+err);
            };
            if (parseInt(info.valor) < parseInt(raiz.ref.value))
            {
                raiz = raiz.ref.esq;
                var atual = 2000*j;
                clearLines(atual);
                highlighter.line(0,10+atual);
                highlighter.line(2,600+atual);
                highlighter.clear(1100+atual);
                highlighter.lineGreen(3,1200+atual);
            }
            else if (parseInt(info.valor) > parseInt(raiz.ref.value))
            {
                raiz = raiz.ref.dir;
                var atual = 2000*j;
                clearLines(atual);
                highlighter.line(0,10+atual);
                highlighter.lineRed(2,500+atual);
                highlighter.line(4,1000+atual);
                highlighter.clear(1400+atual);
                highlighter.lineGreen(5,1500+atual);
            }
            else
            {
                var atual = 2000*j;
                highlighter.clear(atual);
                highlighter.lineRed(0,500+atual);
                highlighter.line(7,1000+atual);
                highlighter.line(9,10,1000+atual);
                if (raiz.ref.dir.ref.ref == null)
                {
                    highlighter.line(11,2000+atual);
                    highlighter.line(12,3000+atual);
                    highlighter.line(24,4000+atual);
                    highlighter.clear(6000+atual);
                }
                else if(raiz.ref.esq.ref.ref == null)
                {
                    highlighter.lineRed(11,2000+atual);
                    highlighter.line(13,2000+atual);
                    highlighter.line(14,3000+atual);
                    highlighter.line(24,4000+atual);
                    highlighter.clear(6000+atual);
                }
                else{
                    highlighter.lineRed(11,2000+atual);
                    highlighter.lineRed(13,2000+atual);
                    highlighter.line(15,2000+atual);
                    highlighter.line(17,3000+atual);
                    highlighter.line(18,4000+atual);   
                    highlighter.lines(19,20,5000+atual);
                    highlighter.line(21,6000+atual);
                    highlighter.line(22,7000+atual);  
                    highlighter.line(24,8000+atual);
                    highlighter.clear(10000+atual);
                }
                break;
            }
            j++;
        }

        if(raiz.ref.ref==null)
        {
            var atual = 2000*j;
            highlighter.clear(atual);
            highlighter.lineRed(0,500+atual);
            highlighter.lineRed(7,1000+atual);
            highlighter.clear(2000+atual);
            setTimeout(function(){
                $("#"+info.id).fadeOut(2000*speed,function(){
                    UI.unlock();
                    $("#"+info.id).remove();
                    window.Eprogramada.nextQueue();
                });
            },(atual+2000)*speed);
            return;
        }
        setTimeout(function () {
            Plumb.moveTo(info.id,pos.left,pos.top,500 * speed);
            

            $("#" + info.id).fadeOut(1000 * speed);

            if (raiz.ref.ref != null) {
                var obj = $("#" + raiz.ref.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);

                if (raiz.ref.dir.ref.ref != null && raiz.ref.esq.ref.ref != null) {
                    var sucessor = collection.getSucessor(raiz);
                    var objsucessor = $("#" + sucessor.ref.id);
                    objsucessor.fadeOut(1000 * speed);
                    objsucessor.fadeIn(1000 * speed);
                    objsucessor.fadeOut(1000 * speed);
                    objsucessor.fadeIn(1000 * speed);
                    objsucessor.fadeOut(1000 * speed);
                    objsucessor.fadeIn(1000 * speed);

                    setTimeout(function () {
                        obj.remove(".itemValue");
                        obj.html("<span class='itemValue' style='top:7px'>" + sucessor.ref.value + "</span>");
                        raiz = sucessor;
                    }, 6000 * speed);
                }

                setTimeout(function () {
                    var pai = getParent(collection.raiz, raiz);
                    if (raiz.ref.dir.ref.ref == null && raiz.ref.esq.ref.ref == null) {
                        if (pai != null) {
                            disconnectDisc(pai, raiz, null);
                        }
                    } else if (raiz.ref.dir.ref.ref != null) {
                        var dir = raiz.ref.dir;
                        Plumb.moveTo(dir.ref.id,parseInt(raiz.ref.d.style.left),parseInt(raiz.ref.d.style.top),2000*speed);
                        setTimeout(function () {
                            disconnectDisc(pai, raiz, dir);
                        }, 2000 * speed);


                    } else {
                        var esq = raiz.ref.esq;
                        Plumb.moveTo(esq.ref.id,parseInt(raiz.ref.d.style.left),parseInt(raiz.ref.d.style.top),2000*speed);
                        setTimeout(function () {
                            disconnectDisc(pai, raiz, esq);
                        }, 2000 * speed);
                    }
                }, 6100 * speed);


                setTimeout(function () {
                    $("#" + raiz.ref.id).remove();
                    collection.remove(value);
                    organizarTudo(2000*speed);
                    setTimeout(function(){
                        UI.unlock();
                        window.Eprogramada.nextQueue();
                    },2000*speed);
                }, 9000 * speed);

            }

            setTimeout(function () {
                $("#" + info.id).remove();
            }, 1500 * speed);
        }, j * 2000 * speed + 1000 * speed);

    },
    prepare = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:true,anchor:"Top"});
    },
    prepare2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:false,anchor:"Top"});
    },
    prepare3 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor:[1, 0.8, 0, -1]});
    },
    prepare4 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:false,anchor:[0, 0.8, 0, -1]});
    },
    connectDisc = function (pai, elem) {
        if (pai != null) {
            if (parseInt(pai.ref.value) < parseInt(elem.valor))
                Plumb.conectar(prepare3(pai.ref.id),prepare(elem.id));
            else
                Plumb.conectar(prepare4(pai.ref.id),prepare2(elem.id));
        }
    },
    disconnectDisc = function (pai, filho, neto) {
        if (neto != null) {
            Plumb.desconectar({target: filho.ref.id});
            Plumb.desconectar({target: neto.ref.id});

            if (parseInt(pai.ref.value) < parseInt(neto.ref.value)) {
                Plumb.conectar(prepare3(pai.ref.id),prepare(neto.ref.id));
            } else {
                Plumb.conectar(prepare4(pai.ref.id),prepare2(neto.ref.id));
            }

        } else {
            Plumb.desconectar({target: filho.ref.id});
        }


    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicSmallDot altColor",
            innerHTML:"<span class='itemValue altColorTitle' style='top: 7px'>" + value + "</span>",
            left:"0px",
            top:"75px",
            title:value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.InitFunctions(this.addDisc,this.removeValue,this.searchValue);
            UI.setProperty("primaryColorProperty",true);
            collection.inicia();
            UI.InitInterface(this.search,this.elementToString);
        },
        elementToString: function(id){
            var element = Element.get(id);
            if(element!==undefined){
                var result = {'info':element.value};
                if (element.esq.ref.ref !== null) {
                    var nextId = (element.esq.ref.id * 1).toString(16).toUpperCase();
                    result.esquerda = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.esquerda = 'null';
                if (element.dir.ref.ref !== null) {
                    var nextId = (element.dir.ref.id * 1).toString(16).toUpperCase();
                    result.direita = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.direita = 'null';
                return result;
            }
            return false;
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicSmallDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value('valor',"Insira apenas números inteiros");
                if(value!=='') {
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    var info = createDisc(value);
                    Plumb.tornarArrastavel(info.id);
                    animationAdd(info);
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {

            var value = UI.value('valor',"Insira apenas números inteiros");
            
            if(value!=="") {
                UI.subtitle("Removendo o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationRemove(info);
            }

        },
        searchValue: function () {
            var value = UI.value('valor',"Insira apenas números inteiros");
            value = $.trim(value);
                        
            if(value!=="") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationSearch(info);
            }
        }

    };
})();

