<!DOCTYPE html>
<?PHP
session_start();
session_unset();
$_SERVER['HTTP_REFERER'] = "login";
if(isset($_POST['PATH'])){
    var_dump($_POST['PATH']);
}

?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Entrar - Cadilag</title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/loginstyle.css" rel="stylesheet"/>
        <link href="css/sweetalert.css" rel="stylesheet"/>
        <script src="js/sweetalert.min.js"></script>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
        <script src="js/jquery.complexify.js"></script>
        <script src="js/jquery.complexify.min.js"></script>
        <script src="js/jquery.complexify.banlist.js"></script>
    </head>
    <body>
        <div class='topbar'>
            <div class='title'>
                <p>Cadilag</p>
            </div> 
            <div state='hide' class="load">
                <div id="float"></div>
            </div>
        </div>
        <footer><p>Cadilag Web Beta 1.0 - Unesp FCT - João Gabriel Gomes Nogueira - (2017)</p></footer>
        <div class="principal">
            <div class='area'>
                <div class="title" id="titleaction"><p>Login</p></div>
                <form class="pure-form" id='login' method="post">
                    <div class="title"><p>Insira os dados de acesso</p></div>
                    <input required="required" placeholder="Email" id="email" name="email" type="email"/>
                    <input required="required" style="width: 236px;float:left;margin-right: 0px;z-index:2;" placeholder="Senha" onkeypress="capsLockDetector(event)" status="scan" id="password" name="password" type="password"/>
                    <button type="button" id="viewpassword"></button>
                    <div id="alertCaps" style="display:none;clear: both;top:5px;">Caps Lock está ativo</div>
                    <div class="info" style="top:5px;" state="hide"></div>
                    <div class="logupdiv" style="display: none;top:5px;z-index:1;">
                        <div style="margin-top:10px;" class="progress"><div id="float"></div></div>
                        <div class='alert' style="text-align: center">
                            A barra acima mostrar a força da senha. Tente uma senha <b style="color:#88F">AZUL</b> ou <b style="color:#8F8">VERDE</b>
                            <details style="cursor: default">
                                <summary>Ajuda</summary>
                                <p>Use letras e numeros, e não utilize palavras conhecidas!</p>
                            </details>
                        </div>
                        <input style="margin-top:10px" class='pure-input-1' onkeypress="capsLockDetector(event)" placeholder="Redigite a senha" id="passwordC" type="password" name="passwordC"  />
                    </div>
                    <button class="pure-button pure-button-primary" id="action">Entrar</button>
                    <button type="button" class="pure-button" id="cadastro">Ou Cadastrar</button>   
                </form>
                <input name="persistent" type="checkbox" id="continuelogin"/>
                <label id="labelforcontinuelogin" for="continuelogin">Manter-se Logado</label>
            </div>
        </div>
        <div class="confirmup" state='hide'>
            <div class='area'>
                <div class="buttonback" id='0'></div>
                <form class="pure-form" id='logup2'>
                    <div class="title"><p>Para realizar o cadastro é necessário preencher algumas informações abaixo:</p></div>
                    <div class='label'><p>Nível de Acesso</p></div>
                    <select onchange="changeSelect(this)" id='level'>
                        <option value="aluno">Aluno</option>
                        <option value="professor">Professor</option>
                    </select>
                    <div class='alert'><p id='obs1'>* Ao selecionar o nível de Acesso de Professor é necessário confirmação do admnistrador</p></div>
                    <div class='alert'><p id='obs2'>**Você não consiguirá alterar o Nível de Acesso</p></div>   
                    <button class="pure-button pure-button-primary" id="cadastro">Continuar</button>  
                </form>
            </div>    
        </div>
        <div class="confirmup2" state='hide'>
            <div class='area'>
                <div class="buttonback" id='1'></div>
                <form class="pure-form" id='logup3'>
                    <div class="title"><p>Insira alguns detalhes do Perfil:</p></div>
                    <div class="pure-u-2-5">
                        <input placeholder="Apelido" maxlength="40" class="pure-input-1" id="nickname" name="nickname" type="text"/>
                    </div>
                    <div class="pure-u-2-5">
                        <input placeholder="Primeiro Nome" maxlength="40" class="pure-input-1" id="firstname" name="fname" type="text"/>
                    </div>
                    <div class="pure-u-2-5">
                        <input placeholder="Último Nome" maxlength="40" class="pure-input-1" id="lastname" name="lname" type="text"/>
                    </div>
                    <p id='obs1'>* São opcionais</p>
                    <button class="pure-button pure-button-primary" id="logupCheckOut">Terminar</button>
                </form>
            </div>    
        </div>
        <script>

            $("#viewpassword").click(function () {
                if ($("#login #password").attr('type') === 'password') {
                    $("#login #password").attr('type', 'text');
                } else {
                    $("#login #password").attr('type', 'password');
                }
            });

            $("#login #cadastro").click(function () {

                if ($(".logupdiv").css('display') === 'none') {

                    var email = $('#login #email').val();
                    var senha = $('#login #password').val();

                    if (email === '') {
                        $('#login .info').attr('state', 'show');
                        $('#login .info').html('<p>Campo email vazio</p>');
                        return;
                    } else if (senha === '') {
                        $('#login .info').attr('state', 'show');
                        $('#login .info').html('<p>Campo senha vazio</p>');
                        return;
                    } else {
                        $("#continuelogin").fadeOut(400);
                        $("#labelforcontinuelogin").fadeOut(400);
                        $("#titleaction").fadeOut(400);
                        $(".logupdiv").fadeIn(400, function () {
                            $("#titleaction").html('<p>Sign up</p>');
                            $("#login #cadastro").html("Voltar");
                            $("#login #action").html("Cadastrar");

                            $(".logupdiv").css("display", "block");
                            $("#titleaction").fadeIn(400);

                        });
                    }
                } else {
                    $("#titleaction").fadeOut(400);
                    $("#continuelogin").fadeIn(400);
                    $("#labelforcontinuelogin").fadeIn(400);
                    $(".logupdiv").fadeOut(400, function () {
                        $(".logupdiv").hide();
                        $("#titleaction").fadeIn(400);
                        $("#titleaction").html('<p>Login</p>');
                        $("#login #cadastro").html("Ou Cadastrar");
                        $("#login #action").html("Entrar");
                    });

                }
            });

            function capsLockDetector(e) {
                kc = e.keyCode ? e.keyCode : e.which;
                sk = e.shiftKey ? e.shiftKey : ((kc === 16) ? true : false);
                if (((kc >= 65 && kc <= 90) && !sk) || ((kc >= 97 && kc <= 122) && sk))
                    document.getElementById('alertCaps').style.display = 'block';
                else
                    document.getElementById('alertCaps').style.display = 'none';
            }

            if (localStorage.getItem("emailCadilag") !== null && localStorage.getItem("senhaCadilag") !== null && localStorage.getItem("emailCadilag") !== 'null' && localStorage.getItem("senhaCadilag") !== 'null') {
                
                var postData = {
                    "email": localStorage.getItem("emailCadilag"),
                    "senha": localStorage.getItem("senhaCadilag")
                };

                $.post("./ajax/access.php", postData, function (data, status) {
                    window.location.replace("./profile.php");
                });
            }

            $("#logup3").submit(function (event) {
                event.preventDefault();
            });

            $("#logupCheckOut").click(function () {
                var email = $('#login #email').val();
                var senha = $('#login #password').val();
                var ehAluno = $('#logup2 #level').val() === 'aluno';
                var nickname = $("#logup3 #nickname").val();
                var firstname = $("#logup3 #firstname").val();
                var lastname = $("#logup3 #lastname").val();
                var postData = {
                    "emailc": email,
                    "senhac": senha,
                    "ehAluno": ehAluno,
                    "nickname": nickname,
                    "lastname": lastname,
                    "firstname": firstname
                };

                $.post('./ajax/uploadnewuser.php', postData, function (data, status) {
                    if (data === 'true') {
                        window.location.replace('emailConfirm.php');
                    } else {
                        swal({title: "Opss ...", text: "Foi encontrado um erro!", closeOnConfirm: false}, function () {
                            console.log(data);
                        });
                    }
                });

            });

            var changeSelect = function (select) {

                var level = $(select).attr('id');

                switch (level) {
                    case 'level':
                        if ($(select).val() === 'aluno') {
                            $('#obs1').css('font-weight', 'normal');
                            $('#obs1').css('font-size', '12px');
                        } else {
                            $('#obs1').css('font-weight', 'bold');
                            $('#obs1').css('font-size', '14px');
                        }
                        
                        break;
                }

            };

            $('.info').on('click', function () {
                $(this).attr('state', 'hide');
            });

            $(".buttonback[id='0']").on('click', function () {
                if ($(this).attr('disabled') !== 'disabled') {
                    enable('.confirmup');
                    $(".confirmup").attr('state', 'hide');
                    enable('.principal');
                    $(".principal").removeAttr('state');
                    $(".topbar .load #float").animate({'width': "0%"}, 500, "linear", function () {
                        $('.topbar .load').attr('state', 'hide');
                    });
                }
            });

            $(".buttonback[id='1']").on('click', function () {
                if ($(this).attr('disabled') !== 'disabled') {
                    $(".confirmup2").attr('state', 'hide');
                    enable('.confirmup');
                    $(".confirmup").removeAttr('state');
                    enable('.confirmup2');
                    $(".topbar .load #float").animate({'width': "33%"}, 500, "linear");
                }
            });

            $('#login').submit(function (event) {
                event.preventDefault();

                if ($(".logupdiv").css('display') === 'none') {

                    var email = $('#login #email').val();
                    var senha = $('#login #password').val();

                    if (email === '') {
                        swal("Email", 'está faltando', 'error');
                        return;
                    }

                    if (senha === '') {
                        swal("Senha", 'está faltando', 'error');
                        return;
                    }

                    var postData = {
                        "email": email,
                        "senha": senha
                    };

                    $('.topbar .load').attr('state', 'show');
                    $(".topbar .load #float").animate({'width': "100%"}, 500, "linear", function () {
                        $.post('./ajax/access.php', postData, function (dataencoded, status) {
                            try{
                                var retorno = JSON.parse(dataencoded);
                            }catch(e){
                                alert("falha interna no servidor");
                                console.log(dataencoded);
                            }
                            if (retorno.resultado) {
                               if(document.getElementById('continuelogin').checked){
                                   localStorage.setItem("emailCadilag",email);
                                   localStorage.setItem("senhaCadilag",senha);
                               }
                                window.location.href = 'index.php';
                            } else {
                                sweetAlert({title: "Oops...", text: retorno.resposta, type: "error"}, function () {
                                    $('#login .info').attr('state', 'show');
                                    $('#login .info').html('<p>' + retorno.resposta + '</p>');

                                    $(".topbar .load #float").animate({'width': "0%"}, 500, "linear", function () {
                                        $('.topbar .load').attr('state', 'hide');
                                    });
                                });
                            }
                        });
                    });
                } else {
                    logup();
                }
            });

            var checkPassword = function (form) {
                if ($(form + ' #passwordC').val() !== $(form + ' #password').val()) {
                    $(form + ' .info').attr('state', 'show');
                    $(form + ' .info').html('<p>Senhas diferentes!</p>');
                    return false;
                } else {
                    $(form + ' .info').attr('state', 'hide');
                    return true;
                }
            };

            $("#logup #password").on('keyup', function () {
                checkPassword("#logup");
            });

            $("#logup #passwordC").on('keyup', function () {
                checkPassword("#logup");
            });

            $("#login #passwordC").on('keyup', function () {
                checkPassword("#login");
            });

            var disable = function (raiz) {
                $(raiz + ' :input').attr('disabled', true);
                $(raiz + ' :button').attr('disabled', true);
                $(raiz + ' .buttonback').attr('disabled', true);
                $(raiz + ' :input').css('cursor', 'context-menu');
                $(raiz + ' :button').css('cursor', 'context-menu');
                $(raiz + ' .buttonback').attr('cursor', 'context-menu');
            };

            var enable = function (raiz) {
                $(raiz + ' :input').removeAttr('disabled');
                $(raiz + ' :button').removeAttr('disabled');
                $(raiz + ' .buttonback').removeAttr('disabled');
                $(raiz + ' :input').removeAttr('css');
                $(raiz + ' :button').removeAttr('css');
                $(raiz + ' .buttonback').removeAttr('css');
            };

            $('#logup2').submit(function (event) {
                $(".topbar .load #float").animate({'width': "66%"}, 500, "linear");
                event.preventDefault();
                disable('.confirmup');
                $(".confirmup").attr('state', 'blur');
                $(".confirmup2").removeAttr('state');

            });

            logup = function () {
                var email = $('#login #email').val();
                var senha = $('#login #password').val();

                if (email === '') {
                    swal("Email", 'está faltando', 'error');
                    return;
                }
                if (senha === '') {
                    swal("Senha", 'está faltando', 'error');
                    return;
                }
                if (!checkPassword("#login")) {
                    swal("As senhas são diferentes", 'Isso evita que você insira uma senha incorreta ou aleatória!', 'error');
                    return;
                }

                var postData = {
                    "email": email
                };

                $.post("./ajax/emailCheck.php", postData, function (dataencoded) {
                    try{
                        var data = JSON.parse(dataencoded);
                    }catch(e){
                        alert("falha interna no servidor");
                        console.log(data);
                    }
                    if (data.resultado) {
                        $('#login .info').attr('state', 'show');
                        $('#login .info').html('<p>'+data.resposta+'</p>');
                    } else {
                        $(".principal").attr('state', 'blur');

                        $('.topbar .load').attr('state', 'show');
                        $(".topbar .load #float").animate({'width': "15%"}, 1000, "linear");
                        $(".topbar .load #float").animate({'width': "33%"}, 500, "linear");
                        $(".confirmup").removeAttr('state');
                        disable('.principal');
                    }
                });

            };

        </script>
        <script src="js/ScriptComplexify.js"></script>
    </body>
</html>
