<?php

session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    echo 'Erro: sessão fechada';
}
include './config/Database.php';
include './controladores/ControladorUsuario.php';

$email = $_SESSION['email'];

$controlador = new ControladorUsuario();

if (!$controlador->setUser($email)) {
    echo 'Erro: usuário não encontrado';
    return;
}

if (!isset($_POST['id']) && !isset($_POST['index'])) {
    echo 'Erro: Parametro faltando';
    return;
}
$id = $_POST['id'];
$index = $_POST['index'];

if (!$controlador->ehAluno()) {
    include './controladores/Professor.php';
    $professor = $controlador->getProfessor();

    include './controladores/Turma.php';

    $turma = $professor->getTurmaByIndex($index);

    include './entidades/Atividade.php';

    if (!$turma->deleteArquivosAtividade($id)) {
        echo 'Falha de Banco';
        return;
    }

    if (!$turma->deleteAtividade($id)) {
        echo 'Falha de Banco';
        return;
    }

    header('location: ./class.php?&index=' . $_POST['index']);
} else {
    echo 'Erro: Aluno não possui permissão para esta operação!';
}
    
