
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
    </head>
    <body>
        <?PHP
        session_start();
        if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
            echo 'erro: sessão fechada';
            return;
        }
        include './config/Database.php';
        include './controladores/ControladorUsuario.php';
        include './controladores/Professor.php';
        include './controladores/Turma.php';
        include './entidades/Atividade.php';
        $email = $_SESSION['email'];

        $controlador = new ControladorUsuario();
        if (!$controlador->setUser($email)) {
            echo 'erro: usuário não encontrado';
            return;
        }

        if (!$controlador->ehAluno()) {
            $controlador = $controlador->getProfessor();


            if (!isset($_POST['titulo']) || !isset($_FILES['url']) || !isset($_POST['index']) || !isset($_POST['id'])) {
                echo 'Formato de Arquivo não aceitável. Não utilizar executável ou arquivo compactado com executável';
//            echo 'erro: alguns dos parametros não encontrado';
//            $a = $_POST['titulo'];
//            $b = $_FILES['url'];
//            $c = $_POST['index'];
//            $e = $_POST['id'];            
                return;
            }

            $index = (int) $_POST['index'];
            $titulo = strip_tags($_POST['titulo']);
            $id = (int) $_POST['id'];
            $turma = $controlador->getTurmaByIndex($index);

            $file = $_FILES['url'];
            if (!$turma) {
                echo 'Turma não encontrada';
                return;
            }
            $atividade = $turma->getAtividade($id);

            if (!$atividade) {
                echo 'Atividade não encontrada';
                return;
            }


            if (!$turma->novoArquivo($titulo, $controlador->getUserId(), $file, $id)) {
                echo 'erro no banco';
                return;
            }
            header('location: ./atividadeview.php?index=' . $index . '&id=' . $id);
        } else {
            echo 'erro: usuário não é um professor';
        }
        ?>
    </body>
</html>