
<!DOCTYPE html>
<html>
    <head>
        <meta charset="UTF-8">
        <title></title>
    </head>
    <body>
        <?php
        session_start();
        if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
            echo 'erro: sessão fechada';
            return;
        }
        include './config/Database.php';
        include './controladores/ControladorUsuario.php';
        include './controladores/Professor.php';
        include './controladores/Turma.php';
        $email = $_SESSION['email'];

        $controlador = new ControladorUsuario();
        if (!$controlador->setUser($email)) {
            echo 'erro: usuário não encontrado';
            return;
        }

        if (!$controlador->ehAluno()) {
            $controlador = $controlador->getProfessor();


            if (!isset($_POST['titulo']) || !isset($_POST['url']) || !isset($_POST['index'])) {
                echo 'erro: alguns dos parametros não encontrado';
                $a = $_POST['titulo'];
                $b = $_POST['url'];
                $c = $_POST['index'];
                return;
            }

            $index = (int) $_POST['index'];
            $titulo = strip_tags($_POST['titulo']);
            $url = $_POST['url'];
            $turma = $controlador->getTurmaByIndex($index);
            if (!$turma) {
                echo 'Turma não encontrada';
                return;
            }

            if (!$turma->novoLink($titulo, $url)) {
                echo 'erro no banco';
                return;
            }

            echo '<form action="./classedit.php" method="GET" id="return"><input type="hidden" name="index" value="' . $index . '"></input></form>';
        } else {
            echo 'erro: usuário não é um professor';
        }
        ?>
        <script>

            if ('1' === '<?php echo '1' ?>')
            {
                document.getElementById("return").submit();
            }

        </script>
    </body>
</html>
