<?php

session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    echo 'Erro: sessão fechada';
}
include './config/Database.php';
include './controladores/ControladorUsuario.php';
include './controladores/Turma.php';
include './entidades/Arquivo.php';
$email = $_SESSION['email'];

$controlador = new ControladorUsuario();

$controlador->setUser($email);

if (!isset($_POST['id'])) {
    echo 'Parametros faltando:';
    $a = $_POST['id'];
    return;
}

$id = (int) $_POST['id'];

if ($controlador->ehAluno()) {
    include './controladores/Aluno.php';
    $aluno = $controlador->getAluno();
    $turma = $aluno->getTurma();
    $arquivo = $turma->getArquivo($id);
    if ((int) $arquivo->getIduser() === (int) $turma->getIdprofessor() || (int) $arquivo->getIduser() === (int) $aluno->getUserId()) {
        download($arquivo);
    }
} else {

    if (!isset($_POST['index'])) {
        echo 'Parametros faltando:';
        $a = $_POST['index'];
        return;
    }

    $index = (int) $_POST['index'];

    include './controladores/Professor.php';
    $professor = $controlador->getProfessor();
    $turma = $professor->getTurmaByIndex($index);
    $arquivo = $turma->getArquivo($id);

    download($arquivo);
}

function download($arquivo) {
    set_time_limit(0);

    if (!file_exists($arquivo->getCaminho())) {
        exit;
    }

    header('Content-Description: File Transfer');
    header('Content-Disposition: attachment; filename="' . $arquivo->getNome() . '"');
    header('Content-Type: application/octet-stream');
    header('Content-Transfer-Encoding: binary');
    header('Content-Length: ' . filesize($arquivo->getCaminho()));
    header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
    header('Pragma: public');
    header('Expires: 0');
    // Envia o arquivo para o cliente
    readfile($arquivo->getCaminho());
}
