<?php

session_start();

if (!isset($_SESSION['email']) ||
        !isset($_SESSION['senha'])) {
    echo json_encode(array("success" => false, "reply" => "Sessão fechada"));
    return;
}

include '../../../config/Database.php';
include '../controladores/PDOCadilag.php';
include '../controladores/EpPDO.php';
include '../controladores/ControladorEp.php';
include '../entidades/EntradaProgramada.php';

$id = filter_input(INPUT_POST, 'idEstrutura', FILTER_VALIDATE_INT);
if ($id) {
    
    $email = $_SESSION['email'];
    $password = $_SESSION['senha'];

    $controladorEp = new controladores\ControladorEp();

    if (!$controladorEp->checkAcess($email, $password)) {
        echo json_encode(array("success" => false, "reply" => "Erro de Sessão"));
        exit();
    }

    $resultSQL = $controladorEp->listEp((int) $id);
    echo json_encode($resultSQL, JSON_PRETTY_PRINT);
    
} else {
    echo json_encode(array("success" => false, "reply" => "Falha de Filtro"));
}