<?php
session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    echo 'erro: sessão fechada';
    return;
}

include '../../../config/Database.php';
include '../../../controladores/ControladorUsuario.php';
include '../../../controladores/Professor.php';
include '../../../controladores/Turma.php';

$email = $_SESSION['email'];

$controlador = new ControladorUsuario();
$controlador->setUser($email);

if (!$controlador->ehAluno()) {
    $controlador = $controlador->getProfessor();
    if ($controlador->possuiAcesso()) {
        $index = (int) $_POST['index'];
        $pseudo = $_POST['pseudo'];
        $value = ($_POST['value'] === 'true');
        $idestrutura = (int) $_POST['edid'];
        $turma = $controlador->getTurmaByIndex($index);
        
        if ($turma->setPermission($idestrutura, $pseudo, $value)) {
            echo json_encode(array("resultado" => true,"resposta" => "Acesso concedido"));
        } else {
            echo json_encode(array("resultado" => false,"resposta" => "Falha na execução"));
        }
        
    } else {
        echo json_encode(array("resultado" => false,"resposta" => "Espionildo?"));
    } 
} else {
    echo json_encode(array("resultado" => false,"resposta" => "Espionildo?"));
}