<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Insere(INFO,i,j)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l0" title="Declarando variável para pesquisa">busca : booleano;</p>
    <p id="l1" title="Realizando busca no índices de inserção">busca := Busca(i,j);</p>
    <p id="l2" title="Caso a posição estiver vazia e respeitar as dimensões da matriz" class="handlerTab">Se busca == Falso e i < N_LINHAS e j < N_COLUNAS então</p>
    <div class="TabCode">
        <p id="l3">INICIO</p>
        <p id="l4" title="Declarando variáveis para leitura">&nbsp; novo,leitorColuna,leitorLinha,anteriorColuna,anteriorLinha : EstruturaLista;</p>
        <p id="l5" title="Declarando variáveis para leitura">&nbsp; coluna,linha : inteiro;</p>
        <p>&nbsp;</p>
        <p id="l6" title="Alocando novo elemento">&nbsp; novo := alocar();</p>
        <p id="l7" title="Definindo linha do novo elemento">&nbsp; novo.linha := i;</p>
        <p id="l8" title="Definindo coluna do novo elemento">&nbsp; novo.coluna := j;</p>
        <p id="l9" title="Definindo o valor do novo elemento">&nbsp; novo.info := INFO;</p>
        <p>&nbsp;</p>
        <p id="l10" title="Posicionando leitor no inicio da Coluna de inserção">&nbsp; leitorColuna := Colunas[j];</p>
        <p id="l11" title="Posicionando leitor no inicio da Linha de inserção">&nbsp; leitorLinha := Linhas[i];</p>
        <p>&nbsp;</p>
        <p id="l12" title="Se a Coluna não estiver vazia" class="handlerTab">&nbsp; Se leitorColuna != nulo então</p>
        <div class="TabCode">
            <p id="l13">INICIO</p>
            <p id="l14" title="Variável de leitura recebe primeira linha que cruza com a coluna de inserção">&nbsp; linha := Colunas[j].linha;</p>
            <p>&nbsp;</p>
            <p id="l15" class="handlerTab" title="Percorrendo linhas que cruzam com a coluna até a linha de inserção">&nbsp; Enquanto leitorColuna.abaixo != nulo e linha < i faça</p>
            <div class="TabCode">
                <p id="l16">INICIO</p>
                <p id="l17" title="Armazenando a linha atual">&nbsp; anteriorColuna := leitorColuna;</p>
                <p id="l18" title="Leitor avança para o elemento abaixo na coluna">&nbsp; leitorColuna := leitorColuna.abaixo;</p>
                <p id="l19" title="Variável de leitura recebe a linha atual que cruza com a coluna">&nbsp; linha := leitorColuna.linha;</p>
                <p id="l20">FIM</p>
            </div>
            <p>&nbsp;</p>
            <p id="l21" class="handlerTab" title="Se não for o último elemento da coluna">&nbsp; Se leitorColuna.abaixo != nulo então </p>
            <div class="TabCode">
                <p id="l22">INICIO</p>
                <p id="l23" class="handlerTab" title="Se for antes do primeiro elemento da coluna">&nbsp; Se anteriorColuna == nulo então</p>
                <div class="TabCode">
                    <p id="l24">INICIO</p>
                    <p id="l25" title="Novo elemento aponta para o primeiro elemento da coluna">&nbsp; novo.abaixo := leitorColuna;</p>
                    <p id="l26" title="Primeiro elemento da coluna passa a ser o novo elemento">&nbsp; Colunas[j] := novo;</p>
                    <p id="l27">FIM</p>
                </div>
                <p id="l28" class="handlerTab" title="Se for depois do primeiro elemento da coluna">&nbsp; Senão</p>
                <div class="TabCode">
                    <p id="l29">INICIO</p>
                    <p id="l30" title="Novo elemento aponta para a leitor">&nbsp; novo.abaixo := leitorColuna;</p>
                    <p id="l31" title="Elemento anterior aponta para o novo elemento">&nbsp; anteriorColuna.abaixo := novo;</p>
                    <p id="l32">FIM</p>
                </div>
                <p id="l33">FIM</p>
            </div>
            <p id="l34" class="handlerTab" title="Se for o último elemento da coluna">&nbsp; Senão</p>
            <div class="TabCode">
                <p id="l35">INICIO</p>
                <p id="l36" title="Novo elemento aponta para nulo">&nbsp; novo.abaixo := nulo;</p>
                <p id="l37" title="Elemento anterior aponta para o novo">&nbsp; anteriorColuna.abaixo := novo;</p>
                <p id="l38">FIM</p>
            </div>
            <p id="l39">FIM</p>
        </div>
        <p id="l40" class="handlerTab" title="Caso a coluna estiver vázia">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l41">INICIO</p>
            <p id="l42" title="Novo elemento aponta para nulo">&nbsp; novo.abaixo := nulo;</p>
            <p id="l43" title="Novo elemento tornasse o primeiro elemento da coluna">&nbsp; Colunas[j] := novo;</p>
            <p id="l44">FIM</p>
        </div>
        <p>&nbsp;</p>
        <p id="l45" class="handlerTab" title="Se a linha não estiver vazia">&nbsp; Se leitorLinha != nulo então</p>
        <div class="TabCode">
            <p id="l46">INICIO</p>
            <p id="l47" title="Variável de leitura aponta para o primeira coluna que cruza com a linha de inserção">&nbsp; coluna := Linhas[i].coluna;</p>
            <p>&nbsp;</p>
            <p id="l48" class="handlerTab" title="Percorrendo colunas que cruzam com a linha até a coluna de inserção">&nbsp; Enquanto leitorLinha.direita != nulo e coluna < j faça</p>
            <div class="TabCode">
                <p id="l49">INICIO</p>
                <p id="l50" title="Armazenando a coluna atual">&nbsp; anteriorLinha := leitorLinha;</p>
                <p id="l51" title="Leitor avança para o elemento abaixo na linha">&nbsp; leitorLinha := leitorLinha.direita;</p>
                <p id="l52" title="Variável de leitura recebe a coluna atual que cruza com a linha">&nbsp; coluna := leitorLinha.coluna;</p>
                <p id="l53">FIM</p>
            </div>
            <p id="l54" class="handlerTab" title="Se não for o último elemento da linha">&nbsp; Se leitorLinha.direita != nulo então</p>
            <div class="TabCode">
                <p id="l55">INICIO</p>
                <p id="l56" class="handlerTab" title="Se for antes do primeiro elemento da linha">&nbsp; Se anteriorLinha == nulo então</p>
                <div class="TabCode">
                    <p id="l57">INICIO</p>
                    <p id="l58" title="Novo elemento aponta para o primeiro elemento da linha">&nbsp; novo.direita := leitorLinha;</p>
                    <p id="l59" title="Primeiro elemento da coluna passa a ser o novo elemento">&nbsp; Linhas[i] := novo;</p>
                    <p id="l60">FIM</p>
                </div>
                <p id="l61" class="handlerTab" title="Se for depois do primeiro elemento da coluna">&nbsp; Senão</p>
                <div class="TabCode">
                    <p id="l62">INICIO</p>
                    <p id="l63" title="Novo elemento aponta para a leitor">&nbsp; novo.direita := leitorLinha;</p>
                    <p id="l64" title="Elemento anterior aponta para o novo elemento">&nbsp; anteriorLinha.direita := novo;</p>
                    <p id="l65">FIM</p>
                </div>
                <p id="l66">FIM</p>
            </div>
            <p id="l67" class="handlerTab" title="Se for o último elemento da linha">&nbsp; Senão</p>
            <div class="TabCode">
                <p id="l68">INICIO</p>
                <p id="l69" title="Novo elemento aponta para nulo">&nbsp; novo.direita := nulo;</p>
                <p id="l70" title="Elemento anterior aponta para o novo">&nbsp; anteriorLinha.direita := novo;</p>
                <p id="l71">FIM</p>
            </div>
            <p id="l72">FIM</p>
        </div>
        <p id="l73" class="handlerTab" title="Caso a linha estiver vazia">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l74">INICIO</p>
            <p id="l45" title="Novo elemento aponta para nulo">&nbsp; novo.direita := nulo;</p>
            <p id="l46" title="Novo elemento tornasse o primeiro elemento da linha">&nbsp; Linhas[i] := novo;</p>
            <p id="l77">FIM</p>
        </div>
        <p>&nbsp;</p>
        <p id="l78">FIM</p>
    </div>
</div>