<div class="Separator"></div>
<div class="head-line">
    <font style="font-size:18px;">FUNÇÃO</font><br>
    Busca(ArvoreNo,INFO)
</div>
<div class="subhead-item">
    <font style="font-size:18px;">RETORNA</font><br>
    Se o valor está na Árvore
</div>	
<div class="Separator"></div>
<div class="code">
    <p id="l0">compBusca,compBuscaNo : inteiro;</p>
    <p id="l1">compBusca := Comprimento(busca);</p>
    <p id="l2">compBuscaNo := Comprimento(No.Palavra);</p>
    <br>
    <p id="l3" class="handlerTab">Se compBusca < compBuscaNo então</p>
    <div class="TabCode">
        <p id="l4">INICIO</p>
        <p id="l5" class="handlerTab">&nbsp; Se busca[0] > No.Palavra[0] então</p>
        <div class="TabCode">
            <p id="l6">INICIO</p>
            <p id="l7" class="handlerTab">&nbsp; Se Direita!=nulo então</p>
            <div class="TabCode">
                <p id="l8">&nbsp; Retornar Busca(No.Direita,busca);</p>
            </div>
            <p id="l9">&nbsp; Senão</p>
            <p id="l10">&nbsp; Retornar Falso;</p>
            <p id="l11">FIM</p>
        </div>
        <p id="l12">&nbsp; Retornar Falso;</p>
        <p id="l13">FIM</p>
    </div>
    <br>
    <p id="l14">String b = SubPalavra(busca,0,compBuscaNo);</p>
    <br>
    <p id="l15" class="handlerTab">Se b[0] > No.Palavra[0] então</p>
    <div class="TabCode">
        <p id="l16">INICIO</p>
        <p id="l17" class="handlerTab">&nbsp; Se Direita!=nulo então</p>
        <div class="TabCode">
            <p id="l18">&nbsp; Retornar busca(No.Direita,busca);</p>
        </div>
        <p id="l19">&nbsp; Senão</p>
        <p id="l20">&nbsp; Retornar Falso;</p>
        <p id="l21">FIM</p>
    </div>
    <br>
    <p id="l22" class="handlerTab">Se Igual(b,No.Palavra) então</p>
    <div class="TabCode">
        <p id="l23">INICIO</p>
        <p id="l24" class="handlerTab">&nbsp; Se compBusca == compBuscaNo então</p>
        <div class="TabCode">
            <p id="l25">&nbsp; Retornar No.PalavraFinal;</p>
        </div>
        <p id="l26" class="handlerTab">&nbsp; Senão Se Abaixo != nulo então</p>
        <div class="TabCode">
            <p id="l27">&nbsp; Retornar busca(No.Abaixo,SubPalavra(busca,compBuscaNo,compBusca));</p>
        </div>
        <p id="l28">&nbsp; Senão</p>
        <p id="l29">&nbsp; Retornar Falso;</p>
        <p id="l30">FIM</p>
    </div>
    <br>
    <p id="l31">Retornar Falso;</p>
</div>
<div class="Separator"></div>
<div class="head-line">
    <font style="font-size:18px;">FUNÇÃO</font><br>
    SubPalavra(Palavra,inicio,fim)
</div>
<div class="subhead-item">
    <font style="font-size:18px;">RETORNA</font><br>
    Parte de uma Palavra 
</div>
<div class="Separator"></div>
<div class="code">
    <p id="l83">saida : array de caracter tamanho fim-inicio; </p>
    <p id="l84">j : inteiro;</p>
    <p id="l85">j := 0;</p>
    <p id="l86" class="handlerTab">Para i:inteiro de inicio até fim passo 1 faça</p>
    <div class="TabCode">
        <p id="l87">INICIO</p>
        <p id="l88">&nbsp; saida[j]:=Palavra[i];</p>
        <p id="l89">&nbsp; j:=j+1;</p>
        <p id="l90">FIM</p>
    </div>
    <p id="l91">Retornar saida;</p>
</div>
<div class="Separator"></div>
<div class="head-line">
    <font style="font-size:18px;">FUNÇÃO</font><br>
    Comprimento(Palavra) 
</div>
<div class="subhead-item">
    <font style="font-size:18px;">RETORNA</font><br>
    Total de letras possui a Palavra
</div>
<div class="Separator"></div>
<div class="code">
    <p id="l92">i : inteiro;</p>
    <p id="l93">i := 0;</p>
    <p id="l94" class="handlerTab">Enquanto Palavra[i] == nulo ou Palavra[i]=='\0' faça</p>
    <div class="TabCode">
        <p id="l95">&nbsp; i:=i+1;</p>
    </div>
    <p id="l96">Retornar i;</p>
</div>