<div class="Separator"></div>
<div class="head-line"> <font style="font-size:18px;">FUNÇÃO</font><br>Remove(No,Pai,Info)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l0" class="handlerTab">Se No != nulo então</p>
    <div class="TabCode">
        <p id="l1">INICIO</p>
        <p id="l2" class="handlerTab">&nbsp; Se No.Info < Info então</p>
        <div class="TabCode">
            <p id="l3">INICIO</p>
            <p id="l4">&nbsp; Remove(No.Direita,No,Info);</p>
            <p id="l5" class="handlerTab">&nbsp; Se Abs(FatorBalanceamento(No)) >= 2 então</p>
            <div class="TabCode">
                <p id="l6">&nbsp; Verifica(Pai,No);</p>
            </div>
            <p id="l7">FIM</p>
        </div>
        <p id="l8" class="handlerTab">&nbsp; Senão se No.Info > Info então</p>
        <div class="TabCode">
            <p id="l9">INICIO</p>
            <p id="l10">&nbsp; Remove(No.Esquerda,No,Info);</p>
            <p id="l11" class="handlerTab">&nbsp; Se Abs(FatorBalanceamento(No)) >= 2 então</p>
            <div class="TabCode">
                <p id="l12">&nbsp; Verifica(Pai,No);</p>
            </div>
            <p id="l13">FIM</p>
        </div>
        <p id="l14" class="handlerTab">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l15">INICIO</p>
                <p id="l16" class="handlerTab">&nbsp; Se No.Direita == nulo então</p>
                <div class="TabCode">
                    <p id="l17">No := No.Esquerda;</p>
                </div>
                <p id="l18" class="handlerTab">&nbsp; Senão Se No.Esquerda == nulo então</p>
                <div class="TabCode">
                    <p id="l19">No := No.Direita;</p>
                </div>
                <p id="l20" class="handlerTab">&nbsp; Senão</p>
                <div class="TabCode">
                    <p id="l21">INICIO</p>
                        <p id="l22">&nbsp; RemoveSucessor(No,No.Direita,No);</p>
                        <p id="l23" class="handlerTab">&nbsp; Se Abs(FatorBalanceamento(No)) >= 2 então</p>
                        <div class="TabCode">
                            <p id="l24">&nbsp; Verifica(Pai,No);</p>
                        </div>
                    <p id="l25">FIM</p>
                </div>
            <p id="l26">FIM</p>
        </div>
        <p id="l27">FIM</p>
    </div>
</div>
<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>FatorBalanceamento(No)</div>
<div class="subhead-item"><font style="font-size:18px;">RETORNA</font><br>O nível de balanceamento da árvore</div>
<div class="Separator"></div>
<div class="code">
    <p id="l28">Retornar Altura(No.Direita) - Altura(No.Esquerda);</p>
</div>
<div class="Separator"></div>
    <div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Altura(No)</div>
    <div class="subhead-item"><font style="font-size:18px;">RETORNA</font><br>A altura a partir do No</div>
<div class="Separator"></div>
<div class="code">
    <p id="l29" class="handlerTab">Se No == nulo então</p>
    <div class="TabCode">
        <p id="l30">&nbsp; Retornar -1;</p>
    </div>
    <br>
    <p id="l31">Retornar Max( Altura(No.Esquerda) + 1 ,Altura(No.Direita) + 1 )</p>
</div>
<div class="Separator"></div>
    <div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Verifica(Pai,No)</div>
    <div class="subhead-item"><font style="font-size:18px;">RETORNA</font><br>Verifica qual será a Rotação na árvore</div>
<div class="Separator"></div>
<div class="code">
    <p id="l32">fb : Inteiro;</p>
    <p id="l33">fb := FatorBalanceamento(No);</p>
    <br>
    <p id="l34" class="handlerTab">Se fb > 0 então</p>
    <div class="TabCode">
        <p id="l35">INICIO</p>
        <p id="l36" class="handlerTab">&nbsp; Se FatorBalanceamento(No.Direita) > 0 então</p>
        <div class="TabCode">
            <p id="l37">&nbsp; RotaçãoEsquerda(Pai,No);</p>
        </div>
        <p id="l38" class="handlerTab">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l39">INICIO</p>
            <p id="l40">&nbsp; RotaçãoDireita(No,No.Direita);</p>
            <p id="l41">&nbsp; RotaçãoEsquerda(Pai,No);</p>
            <p id="l42">FIM</p>
        </div>
        <p id="l43">FIM</p>
    </div>
    <p id="l44" class="handlerTab">Senão</p>
    <div class="TabCode">
        <p id="l45">INICIO</p>
        <p id="l46" class="handlerTab">&nbsp; Se FatorBalanceamento(No.Esquerda) < 0 então</p>
        <div class="TabCode">
            <p id="l47">&nbsp; RotaçãoDireita(Pai,No);</p>
        </div>
        <p id="l48" class="handlerTab">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l49">INICIO</p>
            <p id="l50">&nbsp; RotaçãoEsquerda(No,No.Esquerda);</p>
            <p id="l51">&nbsp; RotaçãoDireita(Pai,No);</p>
            <p id="l52">FIM</p>
        </div>
        <p id="l53">FIM</p>
    </div>
</div>
<div class="Separator"></div>
    <div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>RotaçãoEsquerda(Pai,No)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l54">q : EstruturaAVL;</p>
    <p id="l55">temp : EstruturaAVL;</p>
    <p id="l56">q := No.Direita;</p>
    <p id="l57">temp := q.Esquerda;</p>
    <br>
    <p id="l58">q.Esquerda = No;</p>
    <p id="l59">No.Direita = temp;</p>
    <br>
    <p id="l60" class="handlerTab">Se Pai != nulo então</p>
    <div class="TabCode">
        <p id="l61">INICIO</p>
        <p id="l62" class="handlerTab">&nbsp; Se Pai.Direita == No então</p>
        <div class="TabCode">
            <p id="l63">&nbsp; Pai.Direita := q;</p>
        </div>
        <p id="l64" class="handlerTab">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l65">&nbsp; Pai.Esquerda := q;</p>
        </div>
        <p id="l66">FIM</p>
    </div>
    <p id="l67" class="handlerTab">Senão</p>
    <div class="TabCode">
        <p id="l68">&nbsp; No := q;</p>
    </div>
    <br>
</div>
<div class="Separator"></div>
    <div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>RotaçãoDireita(Pai,No)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l69">q : EstruturaAVL;</p>
    <p id="l70">temp : EstruturaAVL;</p>
    <p id="l71">q := No.Esquerda;</p>
    <p id="l72">temp := q.Direita;</p>
    <br>
    <p id="l73">q.Direita := No;</p>
    <p id="l74">No.Esquerda := temp;</p>
    <br>
    <p id="l75" class="handlerTab">Se Pai != nulo então</p>
    <div class="TabCode">
        <p id="l76">INICIO</p>
            <p id="l77" class="handlerTab">&nbsp; Se Pai.Direita == No então</p>
            <div class="TabCode">
                <p id="l78">&nbsp; Pai.Direita := q;</p>
            </div>
            <p id="l79" class="handlerTab">&nbsp; Senão</p>
            <div class="TabCode">
                <p id="l80">&nbsp; Pai.Esquerda := q;</p>
            </div>
        <p id="l81">FIM</p>
    </div>
    <p id="l82" class="handlerTab">Senão</p>
    <div class="TabCode">
        <p id="l83">&nbsp; No := q;</p>
    </div>
</div>
<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>RemoveSucessor(Q,P,Pai)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l84" class="handlerTab">Se P.Esquerda == nulo então</p>
    <div class="TabCode">
        <p id="l85">&nbsp; Q := P;</p>
        <p id="l86">&nbsp; P := P.Direita;</p>
    </div>
    <p id="l87" class="handlerTab">Senão</p>
    <div class="TabCode">
        <p id="l88">INICIO</p>
            <p id="l89">&nbsp; RemoveSucessor(Q,P.Esquerda,P);</p>
            <p id="l90" class="handlerTab">&nbsp; Se Abs(FatorBalanceamento(Q)) >= 2 então</p>
            <div class="TabCode">
                <p id="l91">&nbsp; Verifica(Pai,Q);</p>
            </div>
        <p id="l92">FIM</p>
    </div>
</div>