<div class="Separator"></div>
<p class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Remove(INFO,ArvoreNo)</p>
<div class="Separator"></div>
<div class="code" >
    <p id="l0" class="handlerTab" title='Se o nó for diferente de nulo e possuir valor diferente do pesquisado continua pesquisando'>Se ArvoreNo != nulo e ArvoreNo.info != INFO então</p>
    <div class="TabCode">
        <p id="l1">INICIO</p>
        <p id="l2" class="handlerTab" title='Se o nó possuir valor menor que o pesquisado'>&nbsp; Se ArvoreNo.info < INFO então</p>
        <div class="TabCode">
            <p id="l3" title='Continua pesquisa recursiva a direita'>&nbsp; Remove(INFO,ArvoreNo.direita);</p>
        </div>
        <br>
        <p id="l4" class="handlerTab" title='Se o nó possuir valor maior que o pesquisado'>&nbsp; Se ArvoreNo.info > INFO então</p>
        <div class="TabCode">
            <p id="l5" title='Continua pesquisa recursiva a esquerda'>&nbsp; Remove(INFO,ArvoreNo.esquerda);</p>
        </div>
        <p id="l6">FIM</p>
    </div>
    <br>	
    <p id="l7" class="handlerTab" title='Se o no for encontrado'>Senão se ArvoreNo != nulo então</p>
    <div class="TabCode">
        <p id="l8">INICIO</p>
        <p id="l9" title='Declarando auxiliar'>&nbsp; Rem : EstruturaArvore;</p>
        <p id="l10">&nbsp; Rem := ArvoreNo;</p>
        <p></p>
        <p id="l11" class="handlerTab" title='Verificando se possui filho a direita'>&nbsp; Se ArvoreNo.direita == nulo então</p>
        <div class="TabCode">
            <p id="l12" title='O sucessor será o filho da esquerda'>&nbsp; ArvoreNo := ArvoreNo.esquerda;</p>
        </div>
        <br>
        <p id="l13" class="handlerTab" title='Verificando se possui filho a esquerda'>&nbsp; Senão se ArvoreNo.esquerda == nulo então</p>
        <div class="TabCode">
            <p id="l14" title='O sucessor será o filho da direita'>&nbsp; ArvoreNo := ArvoreNo.direita;</p>
        </div>
        <br>
        <p id="l15" class="handlerTab" title='Caso possua filho em ambos lados'>&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l16">INICIO</p>
            <p id="l17" title='Declarando cursor para pesquisa do sucessor'>&nbsp; Sucessor : EstruturaArvore;</p>
            <p id="l18" title='Posicionando cursor a direita do elemento encontrado'>&nbsp; Sucessor := ArvoreNo.direita;</p>
            <br>
            <p id="l19" class="handlerTab" title='Seguindo sempre a esquerda'>&nbsp; Enquanto Sucessor.esquerda != nulo faça</p>
            <div class="TabCode">
                <p id="l20" title="Cursor 'sucessor' aponta para o filho a esquerda">&nbsp; Sucessor := Sucessor.esquerda;</p>
            </div>
            <br>
            <p id="l21" title="Trocando valor com o do sucessor">&nbsp; ArvoreNo.info := Sucessor.info;</p>
            <p id="l22" title="Definindo o elemento a ser removido">&nbsp; Rem := Sucessor;</p>							
            <p id="l23">FIM</p>
        </div>
        <br>
        <p id="l24">&nbsp; Liberar(Rem);</p>
        <p id="l25">FIM</p>
    </div>
</div>