<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Remove(INFO)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l0" title="Declarando índice para armazenar resultado da função HASH">indice : inteiro;</p>
    <p id="l1" title="Declarando cursores">leitor,anterior : EstruturaLista;</p>
    <p id="l2" title="Calculando a função HASH">indice := Hash(INFO);</p>
    <p id="l3" title="Posicionando cursor 'leitor' no inicio da lista">leitor := TabelaHash[indice];</p>
    <br>
    <p id="l4" class="handlerTab" title='Percorrendo elementos da lista com valores menores ao pesquisado'>Enquanto leitor != nulo e leitor.info < INFO então</p>
    <div class="TabCode">
        <p id="l5">INICIO</p>
        <p id="l6" title="Cursor 'anterior' aponta para o atual elemento da leitura">&nbsp; anterior := leitor</p>
        <p id="l7" title="Cursor 'leitor' aponta para o próximo elemento da leitura">&nbsp; leitor := leitor.proximo;</p>
        <p id="l8">FIM</p>
    </div>
    <br>
    <p id="l9" class="handlerTab" title='Caso o elemento for encontrado'>Se leitor != nulo e leitor.info == INFO então</p>
    <div class="TabCode">
        <p id="l10">INICIO</p>
        <p id="l11" class="handlerTab" title='Removendo o primeiro elemento da lista'>&nbsp; Se anterior == nulo então</p>
        <div class="TabCode">
            <p id="l12">INICIO</p>
            <p id="l13">&nbsp; TabelaHash[indice]  := TabelaHash[indice].proximo;</p>
            <p id="l14" class="handlerTab" title="Caso não estiver vázia">&nbsp; Se TabelaHash[indice] != nulo então</p>
            <div class="TabCode">
                <p id="l15">&nbsp; TabelaHash[indice].anterior := nulo;</p>
            </div>
            <p id="l16">FIM</p>
        </div>
        <p id="l17" class="handlerTab" title='Removendo um elemento diferente do primeiro da lista'>&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l18">INICIO</p>
            <p id="l19">&nbsp; anterior.proximo := leitor.proximo;</p>
            <p id="l20" class="handlerTab" title="Caso não for o último elemento">&nbsp; Se leitor.proximo != nulo então</p>
            <div class="TabCode">
                <p id="l21">&nbsp; leitor.proximo.anterior := leitor.anterior;</p>
            </div>
            <p id="l22">FIM</p>
        </div>
        <p id="l23">FIM</p>
    </div>
</div>
<div class="Separator"></div>
<div class="head-line">
    <font style="font-size:18px;">FUNÇÃO</font><br>
    Hash(INFO)
</div>
<div class="subhead-item">
    <font style="font-size:18px;">RETORNA</font><br>
    O índice do respectivo valor
</div>
<div class="Separator"></div>
<div class="code">
    <p id="l24" title="Declarando variáveis">soma,total : inteiro;</p>
    <p id="l25" title="Inicializando a soma">soma := 0;</p>
    <p id="l26" title="total recebe o tamanho da palavra">total := INFO.comprimento;</p>
    <br>
    <p id="l27" class="handlerTab" title="Percorrendo cada letra da palavra">Para i de 0 até total passo 1 faça</p>
    <div class="TabCode">
        <p id="l28" title="Info.caracter retorna a posição (do tipo inteiro) na tabela ASCII">&nbsp; soma := soma + (i+1)*INFO.caracter(i);</p>
    </div>
    <br>
    <p id="l29" title="Recuperando resto da divisão, limitando o resultado entre 0 e o tamanho total da tabela Hash">soma := soma % TAMANHO_DA_TABELA;</p>
    <p id="l30" title="Retornando um valor entre 0 e o tamanho total da tabela Hash correspondente a entrada">Retornar soma;</p>
</div>