<div class="Separator"></div>
<div class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Remove(i,j)</div>
<div class="Separator"></div>
<div class="code">
    <p id="l0"  class="handlerTab" title="Se os parâmetros estiverem de acordo com as dimensões da matriz">Se i < N_LINHAS e j < N_COLUNAS então</p>
    <div class="TabCode">
        <p id="l1">INICIO</p>
        <p id="l2" title="Declarando variável para a armazenar a coluna atual">&nbsp; coluna : inteiro;</p>
        <p id="l3" title="Declarando variável para a leitura da linha">&nbsp; leitorLinha,anteriorLinha : EstruturaLista;</p>
        <p id="l4" title="Declarando variável para a leitura da coluna">&nbsp; leitorColuna,anteriorColuna : EstruturaLista;</p>
        <p id="l5" title="Variável 'coluna' recebe o indice da primeira coluna que intercepta a linha">&nbsp; coluna := Linhas[i].coluna;</p>
        <p id="l6" title="Variável de leitura posicionado no início da linha">&nbsp; leitorLinha := Linhas[i];</p>
        <br>
        <p id="l7" class="handlerTab">&nbsp; Enquanto leitorLinha != nulo e coluna != j faça</p>
        <div class="TabCode">
            <p id="l8">INICIO</p>
            <p id="l9">&nbsp; anteriorLinha := leitorLinha;</p>
            <p id="l10">&nbsp; leitorLinha := leitorLinha.direita;</p>
            <p id="l11">&nbsp; coluna := leitorLinha.coluna;</p>
            <p id="l12">FIM</p>
        </div>
        <br>
        <p id="l13" class="handlerTab">&nbsp; Se leitorLinha != nulo então</p>
        <div class="TabCode">
            <p id="l14">INICIO</p>
            <p id="l15">&nbsp; leitorColuna := Colunas[j];</p>
            <br>
            <p id="l16" class="handlerTab">&nbsp; Enquanto leitorColuna != leitorLinha faça</p>
            <div class="TabCode">
                <p id="l17">INICIO</p>
                <p id="l18">&nbsp; anteriorColuna := leitorColuna;</p>
                <p id="l19">&nbsp; leitorColuna := leitorColuna.abaixo;</p>
                <p id="l20">FIM</p>
            </div>
            <br>
            <p id="l21" class="handlerTab">&nbsp; Se anteriorLinha != nulo então</p>
            <div class="TabCode">
                 <p id="l22">&nbsp; anteriorLinha.direita := leitorLinha.direita;</p>
            </div>
            <p id="l23" class="handlerTab">&nbsp; Senão</p>
            <div class="TabCode">
                <p id="l24">&nbsp; Linhas[i] := leitorLinha.direita;</p>
            </div>
            <br>
            <p id="l25" class="handlerTab">&nbsp; Se anteriorColuna != nulo então</p>
            <div class="TabCode">
                <p id="l26">&nbsp; anteriorColuna.abaixo := leitorColuna.abaixo;</p>
            </div>
            <p id="l27" class="handlerTab">&nbsp; Senão</p>
            <div class="TabCode">
                <p id="l28">&nbsp;Colunas[j] := leitorColuna.abaixo;</p>
            </div>
            <br>
            <p id="l29">FIM</p>
        </div>
        <p id="l30">FIM</p>
    </div>
</div>