<div class="Separator"></div>
<p class="head-line"><font style="font-size:18px;">FUNÇÃO</font><br>Remove(INFO)</p>					
<div class="Separator"></div>
<div class="code" >
    <p id="l0" title="Declarando cursores">leitor,anterior : EstruturaLista;</p>
    <p id="l1" title="Inicializando o cursor no primeiro elemento">leitor := Lista;</p>
    <br>
    <p id="l2" class="handlerTab" title="Pesquisando por elemento">Enquanto leitor != nulo e leitor.info != INFO faça</p>
    <div class="TabCode">
        <p id="l3">INICIO</p>
        <p id="l4" title="Cursor 'anterior' aponta para o atual elemento">&nbsp; anterior := leitor;</p>
        <p id="l5" title="Cursor 'leitor' aponta para o próximo elemento">&nbsp; leitor := leitor.proximo;</p>
        <p id="l6">FIM</p>
    </div>
    <br>
    <p id="l7" class="handlerTab" title="Caso o elemento for encontrado">Se leitor != nulo e leitor.info != INFO então</p>
    <div class="TabCode">
        <p id="l8">INICIO</p>
        <p id="l9" class="handlerTab" title="Removendo o primeiro elemento">&nbsp; Se leitor == Lista então</p>
        <div class="TabCode">
            <p id="l10">INICIO</p>
            <p id="l11" class="handlerTab" title="Removendo o único elemento">&nbsp; Se leitor.proximo != nulo então</p>
            <div class="TabCode">
                <p id="l12">leitor.proximo.anterior := nulo;</p>
            </div>
            <br>
            <p id="l13" title="Novo primeiro elemento da lista">&nbsp; Lista := Lista.proximo;</p>
            <p id="l14">FIM</p>
        </div>
        <p id="l15" class="handlerTab" title="Removendo um elemento diferente do primeiro">&nbsp; Senão</p>
        <div class="TabCode">
            <p id="l16">INICIO</p>
            <p id="l17">&nbsp; anterior.proximo := leitor.proximo;</p>
            <p id="l18" class="handlerTab" title="Removendo um elemento diferente do último">&nbsp; Se leitor.proximo == nulo então</p>
            <div class="TabCode">
                <p id="l19">&nbsp; leitor.proximo.anterior := anterior;</p>
            </div>
            <p id="l20">FIM</p>
        </div>
        <p id="l21" title="Desalocando memória">&nbsp; Liberar(leitor);</p>
        <br>
        <p id="l22">FIM</p>
    </div>
</div>