<?PHP
if (!defined('STRUCTVIEW')) {
    exit('No direct script access allowed');
}
$includepath = './includes/';
if (isset($_GET['action'])) {
    $action = $_GET['action'];
    switch ($action) {
        case "editcode":
            if (isset($_GET['idCode'])) {
                ?>
                <script>
                    (function () {
                        document.addEventListener("DOMContentLoaded", function (event) {
                            getDetailsCode(<?= $_GET['idCode'] ?>, function (title, language, idestrutura) {
                                if (idestrutura == <?= $idestrutura ?>) {
                                    getCode(<?= $_GET['idCode'] ?>, language, title,<?= $controlador->getUserId() ?>);
                                    $('#sourcecode-btn').click();
                                    setTimeout(function () {
                                        openEditLineAlgoritmo($(".algoritmo#insercao #l0"));
                                    }, 1000);
                                }
                            });
                        });
                    }());
                </script>
                <?PHP
            }
            break;
        case "openep":
            if (isset($_GET['idEp'])) {
                ?>
                <script>
                    (function () {
                        document.addEventListener("DOMContentLoaded", function (event) {
                            $.post('./ajax/getEp.php', {idEp: <?= $_GET['idEp'] ?>}, function (data) {
                                try {
                                    var retorno = JSON.parse(data);
                                } catch (e) {
                                    window.console.log("falha no Parse:" + data);
                                    swal(
                                            {title: "Opss ...",
                                                type: "error",
                                                text: "ocorreu uma falha no servidor"});
                                    return;
                                }
                                if (retorno.success && retorno.idEstrutura == <?= $idestrutura ?>) {
                                    clearEp();

                                    for (var i = 0; i < retorno.lista.length; i++) {
                                        var ep = retorno.lista[i];
                                        var row = $("#TableEp > tr:not(:first-child)").eq(i);
                                        var j = 0;
                                        for (var key in ep.info) {
                                            getInputObj(i, j).val(ep.info[key]);
                                            j++;
                                        }
                                        switch (ep.function) {
                                            case "add":
                                                pressEpAdd(row.find('.epfunction'));
                                                break;
                                            case "rem":
                                                pressEpRem(row.find('.epfunction'));
                                                break;
                                        }

                                        addNovoItem();

                                    }
                                    setEpDetails(<?= $_GET['idEp'] ?>, retorno.rotulo);
                                    $('#eprogramada-btn').click();
                                } else {
                                    swal({title: "Opss", text: "Ocorreu uma falha", type: "error"});
                                }
                            });
                        });
                    }());
                </script>
                <?PHP
            }
            break;
    }
}
?>
<div id="main">
    <div id="title">
        <p id="subtitle"></p>
        <p><?= $nameestrutura ?></p>
    </div>
</div>
<!--<div id="progressBar">
    <span id="float"></span>
</div>-->
<div id="StructDiv" style="display:none">
    <div class="title">Estruturas e Variaveis</div>
    <div class="Separator"></div>
    <div class="head-line"><font style="font-size:18px;">Estrutura de Dados</font><br></div>
    <div class="Separator"></div>
    <div class="code">
        <?PHP include $includepath . 'estruturas/' . $name_struct; ?>
    </div>
    <?PHP
    $file = $includepath . 'constantes/' . $name_struct;
    if (file_exists($file) && is_readable($file)):
        ?>
        <div class="Separator"></div>
        <div class="head-line"><font style="font-size:18px;">Constantes</font><br></div>
        <div class="Separator"></div>
        <div class="code">
            <?PHP include $file; ?> 
        </div>
        <div class="Separator"></div>
        <div class="head-line"><font style="font-size:18px;">Parametros Definidos</font><br></div>
        <div class="Separator"></div>
        <div class="code" id="parameters">

        </div>
    <?PHP endif; ?>
</div>
<div id="AlgoritmoDiv" style="display:none">
    <div class="appbuttons">
        <button title="Mostrar PseudoCódigo da Inserção" class="selected" id="showinsercao">Inserção</button>
        <button title="Mostrar PseudoCódigo da Remoção" id="showremocao">Remoção</button>
        <button title="Mostrar PseudoCódigo da Busca"  id="showbusca">Busca</button>
    </div>
    <?PHP if ($add && $rem && $search): ?>
        <div class="appoptions">
            <div class="label">Código</div>
            <select id="codeSelect" onchange="changeCodeSelector(this)">
                <optgroup id="onprotectedcodegp" label="Protegidos">
                    <option value="0">Padrão (Pseudo-Código)</option>
                </optgroup>
            </select>
            <button id="newCode" title="Novo Código a partir do atual"></button>
            <button id="loadCode" title="Carregar código salvo"></button>
            <button id="saveCode" disabled title="Salvar Código"></button>
        </div>
        <button id="toggleOptions">=</button>
    <?PHP endif; ?>
    <div class="algoritmo" id="insercao">
        <?php include $includepath . ($add ? 'algoritmos/add/' . $name_struct : 'ui/BlockedCodeSign.php'); ?>
    </div>
    <div class="algoritmo" id="remocao">
        <?php include $includepath . ($rem ? 'algoritmos/rem/' . $name_struct : 'ui/BlockedCodeSign.php'); ?>
    </div>
    <div class="algoritmo" id="busca">
        <?php include $includepath . ($search ? 'algoritmos/busca/' . $name_struct : 'ui/BlockedCodeSign.php'); ?>
    </div>
</div>
<div id="EntradaProgramadaDiv" style="display:none">
    <div class="title">Entradas Programadas</div>
    <div class="appbuttons">
        <button id="eprun" title="Executar entradas">Executar</button>
        <button id="epsave" title="Salvar entradas">Salvar</button>
        <button id="epload" title="Carregar entradas" >Carregar</button>
        <button id="epclear" title="Apagar entradas atuais">Limpar</button>
    </div>
    <p id="openedEpTitle"></p>
    <div class="Separator"></div>
    <table id="TableEp"></table>
    <ul id="EntradaProgramadaUl">

    </ul>
    <div class="appbuttons">
        <button id="ephistory" title="Puxar Histórico">Copiar entrada do Histórico</button>
    </div>
</div>
<div id="ConfigDiv" style="display:none">
    <div class="title">Configurações</div>
    <p>
        <span class="cool-checkbox" id="mobile-interface"><span class="checkspan"></span></span>  
    <div class="label"><p>Manter sempre a interface Compacta</p></div>
    <p>
        <span class="cool-checkbox" id="repetirEntrada"><span class="checkspan"></span></span>  
    <div class="label"><p>Impedir inserção de valores repetidos</p></div>
<!--    <p>
    <span class="cool-checkbox selected" id="enableTemporizador"><span class="checkspan"></span></span>  
    <div class="label"><p>Mostrar Temporizador</p></div>-->
    <p>
        <span class="cool-checkbox" id="enableDescritor"><span class="checkspan"></span></span>  
    <div class="label"><p>Mostrar Descritores</p></div>
    <div id="primaryColor" style="display: none">
        <p>
        <div class="label2">Cor do componente primário</div>
        <div style="display: inline-block; width: 130px;">
            <input title="Clique para editar cor do componente primário" id="colorChooserAlt" class="jscolor {onFineChange:'window.UI.changeColorComponentPrimary(this.valueElement)'}" onchange="window.UI.updateColorPrimary(this.valueElement)" original-value="333333">
            <button title="Clique para resetar a cor do componente primário" class="resetColor" for="colorChooserAlt"></button>
        </div>
    </div>
    <div id="secondaryColor" style="display: none">
        <p>
        <div class="label2">Cor do componente secundário</div>
        <div style="display: inline-block; width: 130px;">
            <input title="Clique para editar cor do componente secundário" id="colorChooserAlt1" class="jscolor {onFineChange:'window.UI.changeColorComponentSecondary(this.valueElement)'}" onchange="window.UI.updateColorSecondary(this.valueElement)" original-value="FF532D">
            <button title="Clique para resetar a cor do componente secundário" class="resetColor" for="colorChooserAlt1"></button>
        </div>
    </div>
</div>
<div id="HistoryDiv" style="display:none">
    <div class="title">Histórico</div>
    <form class="pure-form">
        <label for="historyorder">Ordenar por: </label>
        <select id="historyorder" onchange="History.invertHistory()">
            <option value="last" selected>Mais recente</option>
            <option value="first">Mais antigos</option>
        </select>
    </form>
    <ul id="history-head">
        <li>
            <ul id="title-history">
                <li style="width: 100%">Valor</li>
            </ul>
        </li>
        <li>
            <div id="title-history-funtion"></div>
        </li>
    </ul>
    <ul id="history">
        <li>
            <ul class="item-list-history">
                <li style="width: 100%">Vazio</li>
            </ul>
            <span class="item-history-function"></span>
        </li>
    </ul>
</div>
<div id="huboptions" style="display:none;">
    <a href="../../profile.php" class="option" title="Ir ao Menu Principal"><div class="option">Principal</div></a>
    <a href="../../editprofile.php" class="option" title="Editar o Perfil"><div class="option">Editar Perfil</div></a>
    <a href="../../arquivos.php" class="option" title="Ver Arquivos Salvos"><div class="option">Arquivos</div></a>
    <a href="../../class.php" class="option" title="Ir a turma"><div class="option">Turma</div></a>
    <details class="huboptions-container">
        <summary class="huboptions-container-title">Estruturas</summary>
        <a href="#" class="option" onclick="toggleSidebar()" title="Mostrar Estruturas de Dados"><div class="option">Listar</div></a>
        <a href="./index.php" class="option" title="Menu"><div class="option">Ir para o Menu</div></a>
        <a href="./entradaProgramadas.php" class="option" title="Visualizar Entradas Programadas Salvas"><div class="option">Entradas Programadas</div></a>
        <a href="./codigos.php" class="option" title="Visualizar Códigos Salvos"><div class="option">Códigos</div></a>
    </details>
    <a href="#" onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location = '../../closesession.php';"  class="option" id="sair" title="Encerrar Sessão"><div class="option">Log Off</div></a>
</div>
<div id="sidebar">
    <button id="hidesidebar">Ocultar</button>
    <button id="navsidebar" title="Mais Detalhes">Aplicativos</button>
    <ul>
        <li id="sourcecode-btn" title="Mostrar<br>pseudocódigos"><p>Pseudo-código</p></li>
        <li id="structview-btn" title="Mostrar<br>estruturas e variaveis"><p>Estruturas e Variaveis</p></li>
        <li id="eprogramada-btn" title="Mostrar<br>entradas programadas"><p>Entradas Programadas</p></li>
        <li id="history-btn" title="Mostrar<br>Histórico"><p>Histórico</p></li>
        <li id="config-btn" title="Mostrar<br>configurações"><p>Configurações</p></li>
    </ul>
</div>
<div id="ClockDiv" title="Velocidade<br>da Animação"></div>
<div id="ClockArea">
    <p>Velocidade da Animação</p>
    <input type="range" id="time" min="0.25" max="10" value="1" step="0.05"/>
    <p id="timelabel">1x</div>
</div>
<div id="dialogOpenCode" style="display:none;">
    <div id="selectorCode">
        <p class="title"><?= $nameestrutura ?></p>
        <ul class="content">
            <li class="empty">Vazio</li>
        </ul>
        <div class="sidecontent">
            <button name="onlyUserCode" class="selected">Seus Códigos</button>
            <button name="anotherUsersCode">Outros Códigos</button>
        </div>
        <div class="buttons">
            <button id="cancel" class="pure-button">Voltar</button>
        </div>
    </div>
</div>
<button id="feedback" onclick="report();">
    <svg xmlns="http://www.w3.org/2000/svg" width="35px" height="35px" viewBox="0 0 24 24">
    <path d="M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-7 12h-2v-2h2v2zm0-4h-2V6h2v4z"></path>
    </svg>
</button>
<?PHP include $includepath . 'ui/StructSelector.php'; ?>
<script>
    var idestrutura = '<?= $idestrutura; ?>';
    var iduser = <?= $controlador->getUserId() ?>;
</script>