$(function () {

    var VK_NOTHING = -1;
    var VK_ALGORITMO = 0;
    var VK_EPROGRAMADA = 1;
    var VK_STRUCT = 2;
    var VK_CONFIG = 3;
    var VK_HISTORY = 4;
    var Apps = [["#AlgoritmoDiv"], ['#EntradaProgramadaDiv'], ['#StructDiv'], ['#ConfigDiv'], ['#HistoryDiv']];
    var selectedarea = VK_NOTHING;

    $('#sourcecode-btn').on('click', function () {
        if (toggleAREA(VK_ALGORITMO))
            $(this).addClass('appselected');
    });
    $('#eprogramada-btn').on('click', function () {
        if (toggleAREA(VK_EPROGRAMADA))
            $(this).addClass('appselected');
    });
    $('#structview-btn').on('click', function () {
        if (toggleAREA(VK_STRUCT))
            $(this).addClass('appselected');
    });
    $('#config-btn').on('click', function () {
        if (toggleAREA(VK_CONFIG))
            $(this).addClass('appselected');
    });
    $('#history-btn').on('click', function () {
        if (toggleAREA(VK_HISTORY))
            $(this).addClass('appselected');
    });
    $("#hidesidebar").on('click', function () {
        toggleAREA(selectedarea);
    });
    $("#navsidebar").on('click', function () {
        $("#sidebar").toggleClass("showDetail");
    });
    $(".tip").on('click', function () {
        closeTip($(this));
    });

    closeTip = function (tip) {
        if (tip === undefined)
            tip = $(".tip");
        tip.remove();
    };

    toggleAREA = function (i) {
        $('.appselected').removeClass('appselected');
        closeTip();

        if (selectedarea !== -1) {
            for (var j = 0; j < Apps[selectedarea].length; j++) {
                var objapp = $(Apps[selectedarea][j]);
                objapp.fadeOut(400);
            }
        }
        $("#sidebar").removeClass("showDetail");
        if (i !== selectedarea) {
            $("#hidesidebar").fadeIn(400);
            $("#navsidebar").hide();
            for (var j = 0; j < Apps[i].length; j++) {
                var objapp = $(Apps[i][j]);
                objapp.fadeIn(400);
            }
            selectedarea = i;
            return true;
        } else {
            $("#hidesidebar").hide();
            $("#navsidebar").fadeIn(400);
            selectedarea = VK_NOTHING;
            return false;
        }
    };

});


(function () {

    window.TimeApp = {

        updateTime: function () {

            var timelabel = $("#timelabel");
            var time = $("#time");
            var timeval = time.val();

            timelabel.html(timeval + "x");
            if (parseFloat(timeval) !== 0) {
                setSpeed(1.0 / parseFloat(timeval));
            } else {
                time.val('1.0');
                setSpeed(1);
            }
        }
    },
            window.ButtonApp = {
                lightupAdd: function () {
                    $("#add").addClass("selected");
                    $("#remove").removeClass("selected");
                    $("#search").removeClass("selected");
                },
                lightupRem: function () {
                    $("#add").removeClass("selected");
                    $("#remove").addClass("selected");
                    $("#search").removeClass("selected");
                },
                lightupSearch: function () {
                    $("#add").removeClass("selected");
                    $("#remove").removeClass("selected");
                    $("#search").addClass("selected");
                }

            };
})();

$("#sair").click(function () {
    localStorage.setItem('emailCadilag', null);
    localStorage.setItem('senhaCadilag', null);
    window.location.replace("../../closesession.php");
});