jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function ListaDuplamenteEncadeada() {

    ListaDuplamenteEncadeada.criaNo = function () {
        return {valor: null, dados: null, prox: null, ant: null};
    };

    this.ini = null;

    this.insere = function (valor, dado)
    {
        if (this.ini === null) {
            this.ini = ListaDuplamenteEncadeada.criaNo();
        } else {
            var novo = ListaDuplamenteEncadeada.criaNo();
            novo.prox = this.ini;
            this.ini.ant = novo;
            this.ini = novo;
        }
        Element.bind(this.ini,dado.id);
        this.ini.dados = dado;

        this.ini.valor = valor;
    };

    this.remove = function (dado) {
        var no = this.ini;
        var ant = null;
        while (no != null && no.valor != dado) {
            ant = no;
            no = no.prox;
        }

        if (no)
        {
            if (no == this.ini)
            {
                if (this.ini.prox != null)
                    this.ini.prox.ant = null;

                this.ini = this.ini.prox;
            } else
            {
                ant.prox = no.prox;

                if (no.prox != null)
                    no.prox.ant = ant;
            }
        }

    };

}

(function () {
    var collection = new ListaDuplamenteEncadeada();

    var
    setInitial = function(elId,key){
        $("span.initial").remove();
        if(key){
            $("#"+elId).append("<span class='initial'>Lista</span>");
        }
        setLeftFinal(elId,key);
    },
    setRightFinal = function(elId,key){
        $("span.final").remove();
        if(key){
            $("#"+elId).append("<span class='final'>null</span>");
        }
    },
    setLeftFinal = function(elId,key){
        $("span.final2").remove();
        if(key) {
            $("#"+elId).append("<span class='final2'><p>null</p></span>");
        }
    },
    deslocarApartir = function(raiz,offsetX,speed) {
        while (raiz !== null) {
            deslocar(raiz.dados, offsetX, speed);
            raiz = raiz.prox;
        }
    },
    deslocar = function (raiz, offset, tempo) {
        Plumb.moveTo(raiz.id,parseInt(raiz.d.style.left) + offset,parseInt(raiz.d.style.top),tempo);
    },
    animationAdd = function (elId) {
        UI.lock();
        var speed = getSpeed();
        var raiz = collection.ini.prox;
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        deslocarApartir(raiz,125,2000*speed);

        highlighter.lines(0,2,10);

        if(collection.ini.prox===null) {
            highlighter.clear(499);
            highlighter.lineRed(3,500);
        } else {
            highlighter.line(3,500);
            highlighter.line(5,1000);
            highlighter.line(6,1500);
        }
        setTimeout(function () {
            Plumb.moveTo(elId,75,screen.height / 2.5,1000 * getSpeed());
            highlighter.line(8,0);
            setTimeout(function () {
                if(collection.ini.prox===null)
                {
                    setRightFinal(collection.ini.dados.id,true);
                }
                setInitial(collection.ini.dados.id,true);
                connectDisc();
                highlighter.clear(0);
                UI.unlock();
                window.Eprogramada.nextQueue();
            }, 2000 * speed);

        }, 2000 * speed);
    },
    animationSearch = function (elem) {
        UI.lock();
        var i = 0;
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        highlighter.lines(0,1,10);
        var temp = collection.ini;
        var elemobj = $("#"+elem.id);
        
        while(temp!==null) {
            var pos = {left: parseInt(temp.dados.d.style.left), top: parseInt(temp.dados.d.style.top) - 65};
            Plumb.moveTo(elem.id,pos.left,pos.top,2000 * speed);

            if (elem.valor === temp.valor) {
                highlighter.line(2,2000*(i+1)-1000);
                highlighter.line(4,2000*(i+1));
                highlighter.line(5,2000*(i+1)+1000); 
                highlighter.clear(2000*(i+2));
                break;
            } else {
                highlighter.line(2,2000*i-500);
                highlighter.clear(2000*i-1);
                highlighter.lineRed(4,2000*i);
                highlighter.line(6,2000*i+500);
            }
            temp = temp.prox;
            i++;
        }
        if (temp===null && pos!==undefined) {
            Plumb.moveTo(elem.id,pos.left + 125,pos.top,2000*speed);
        }

        setTimeout(function () {
            if (temp!==null) {
                var id = temp.dados.id;
                var obj = $("#" + id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                setTimeout(function () {
                    UI.unlock();
                    elemobj.remove();
                }, 6000 * speed);

            } else {
                highlighter.clear(0);
                highlighter.lineRed(2,500);
                highlighter.line(8,1000);
                highlighter.clear(2000);
                setTimeout(function () {
                    UI.unlock();
                    elemobj.remove();
                }, 2000 * speed);
            }

            elemobj.fadeOut(1000 * speed);
        }, (i + 1) * 2000 * speed);


    },
    animationRemove = function (elem) {
        UI.lock();
        var i = 0;
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.REMOCAO);
        highlighter.lines(0,1,10);
        var objelem = $("#"+elem.id);
        var temp = collection.ini;
        while(temp!==null) {
            var pos = {left: parseInt(temp.dados.d.style.left), top: parseInt(temp.dados.d.style.top) - 65};
            Plumb.moveTo(elem.id,pos.left,pos.top,2000 * speed);
            if (elem.valor === temp.valor) {
                highlighter.clear(2000*(i+1)+500);
                highlighter.lineRed(2,2000*(i+1) + 600);
                break;
            } else {
                highlighter.line(2,2000*(i+1) + 600);
                highlighter.line(4,2000*(i+1) + 1200);
                highlighter.line(5,2000*(i+1) + 1800);
            }
            i++;
            temp = temp.prox;
        }
        if (temp===null && pos!==undefined) {
            Plumb.moveTo(elem.id,pos.left + 125,pos.top,2000*speed);
        }

        setTimeout(function () {
            highlighter.clear(500);
            if (temp!==null) {
                highlighter.line(7,1000);

                if(temp.ant===null) {
                    highlighter.line(9,1500);
                    if(collection.ini.prox!==null) {
                        highlighter.line(11,2000);
                        highlighter.line(12,2500);
                        highlighter.line(13,3000);
                        highlighter.line(21,3500);
                        highlighter.clear(4000);
                    } else {
                        highlighter.lineRed(11,2000);
                        highlighter.line(13,2500); 
                        highlighter.line(21,3000);
                        highlighter.clear(3500);
                    }
                } else {
                    highlighter.lineRed(9,1500);
                    highlighter.line(15,2000);
                    highlighter.line(17,2500);

                    if(temp.prox===null) {
                        highlighter.line(18,3000);
                        highlighter.line(19,3500);
                        highlighter.line(21,4000);
                        highlighter.clear(4500);
                    } else {
                        highlighter.lineRed(18,3000);
                        highlighter.line(21,3500);
                        highlighter.clear(4000);
                    }
                }

                var obj = $("#" + temp.dados.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                setTimeout(function () {
                    if(temp.ant===null && temp.prox!==null) {
                        setInitial(temp.prox.dados.id,true);
                    }
                    if(temp.prox===null && temp.ant!==null) {
                        setRightFinal(temp.ant.dados.id,true);
                    }
                    disconnectDisc(temp);
                    window.Eprogramada.nextQueue();
                }, 5000 * speed);
            } else {
                highlighter.lineRed(7,1000);
                highlighter.clear(2000);

                setTimeout(function () {
                    UI.unlock();
                    window.Eprogramada.nextQueue();
                }, 2000 * speed);
            }
            objelem.fadeOut(1000 * speed);

            setTimeout(function () {
                objelem.remove();
                if (temp!==null) {
                    $("#" + temp.dados.id).remove();
                    collection.remove(parseInt(elem.valor));
                }
            }, 6000 * speed);

            if (temp!==null)
            {
                setTimeout(function () {
                    var leitor = temp.prox;
                    deslocarApartir(leitor,-125,2000*speed);
                    UI.unlock();
                }, 6300 * speed);
            }
        }, (i + 1.5) * 2000 * speed);

    },

    prepare = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:false,anchor: [1, 0.7, 0, -1]});
    },
    prepare2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:true,anchor: [0, 0.3, 0, -1]});
    },
    prepare3 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor: [1, 0.3, 0, -1]});
    },
    prepare4 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:false,anchor: [0, 0.7, 0, -1]});
    },
    
    connectDisc = function () {
        if (collection.ini.prox!==null){
            var id1 = collection.ini.dados.id;
            var id2 = collection.ini.prox.dados.id;
            Plumb.conectar(prepare(id1),prepare4(id2));
            Plumb.conectar(prepare3(id1),prepare2(id2));
        }
    },
    disconnectDisc = function (elem) {
        Plumb.desconectarCompletamente(elem.dados.id);
        if (elem.ant!==null && elem.prox!==null){
            Plumb.conectar(prepare(elem.ant.dados.id),prepare4(elem.prox.dados.id));
            Plumb.conectar(prepare3(elem.ant.dados.id),prepare2(elem.prox.dados.id));
        }
    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicDot altColor",
            innerHTML:"<span class='itemValue altColorTitle'>" + value + "</span>",
            left:"100px",
            top:"75px",
            title: value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.setProperty("primaryColorProperty",true);
            UI.InitFunctions(this.addDisc,this.removeValue,this.searchValue);
            UI.InitInterface(this.search,this.elementToString);
        },
        elementToString: function(id){
            var element = Element.get(id);
            if(element!==undefined){
                var result = {'info':element.valor};
                if (element.prox !== null) {
                    var nextId = (element.prox.dados.id * 1).toString(16).toUpperCase();
                    result.proximo = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.proximo = 'null';
                if (element.ant !== null) {
                    var nextId = (element.ant.dados.id * 1).toString(16).toUpperCase();
                    result.anterior = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.anterior = 'null';
                return result;
            }
            return false;
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value("valor");
                if (value !== "") {
                    var info = createDisc(value);
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    collection.insere(value, info);
                    Plumb.tornarArrastavel(info.id);
                    animationAdd(info.id);
                    
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {
            var value = UI.value("valor");
            if (value !== "") {
                var info = createDisc(value);
                UI.subtitle("Removendo o valor <b>"+value+"</b>");
                animationRemove(info);
            }

        },
        searchValue: function () {
            var value = UI.value("valor");
            if (value !== "") {
                var info = createDisc(value);
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                animationSearch(info);
            }
        }

    };
})();