jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function ListaSimplesOrdenada() {
    this.cabeca = null;

    ListaSimplesOrdenada.criaNo = function () {
        return {
            dados: null,
            valor: null,
            prox: null,
            ant: null
        };
    };

    this.insere = function (valor, dado) {
        var novo = ListaSimplesOrdenada.criaNo();
        novo.dados = dado;
        novo.valor = valor;
        Element.bind(novo,dado.id);
        var leitor = this.cabeca;
        var anterior = null;
        while (leitor != null && leitor.valor * 1 < valor * 1) {
            anterior = leitor;
            leitor = leitor.prox;
        }
        if (leitor != null) {
            if (anterior == null) {
                novo.prox = this.cabeca;
                this.cabeca.ant = novo;
                this.cabeca = novo;
            } else {
                novo.ant = anterior;
                novo.prox = leitor;
                anterior.prox = novo;
                leitor.ant = novo;
            }
        } else {
            if (anterior == null) {
                this.cabeca = novo;
            } else {
                novo.ant = anterior;
                anterior.prox = novo;
            }
        }
    };
    
}

(function () {
    var collection = new ListaSimplesOrdenada();
    var 
    setInitial = function(elId,key){
        $("span.initial").remove();
        if(key) {
            $("#"+elId).append("<span class='initial'>Lista</span>");
        }
        setLeftFinal(elId,key);
    },
    setRightFinal = function(elId,key){
        $("span.final").remove();
        if(key) {
            $("#"+elId).append("<span class='final'>null</span>");
        }
    },
    setLeftFinal = function(elId,key){
        $("span.final2").remove();
        if(key) {
            $("#"+elId).append("<span class='final2'><p>null</p></span>");
        }
    },
    deslocar = function (dados, offsetX, tempo) {
        Plumb.moveTo(dados.id, parseInt(dados.d.style.left) + offsetX,parseInt(dados.d.style.top), tempo);
    },
    deslocarApartir = function (raiz, offsetX, tempo) {
        while(raiz!==null) {
            deslocar(raiz.dados,offsetX,tempo);
            raiz = raiz.prox;
        }
    },
    foundAnimation = function(id,speed){
        var obj = $("#" + id);
        obj.fadeOut(speed);
        obj.fadeIn(speed);
        obj.fadeOut(speed);
        obj.fadeIn(speed);
        obj.fadeOut(speed);
        obj.fadeIn(speed);
    },
    animationAdd = function (info) {
        UI.lock();

        var posFim = {left: 100, top: screen.height / 2.5};
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        highlighter.lines(1,4,50);
        if (collection.cabeca.prox!==null) {
            var i=0;
            var leitor = collection.cabeca;
            while(leitor!==null) {
                var looptime = 2000*i + 1000;
                if(info.valor*1===leitor.valor*1) {
                    if(leitor.ant!==null) {
                        Plumb.moveTo(info.id,posFim.left+125,posFim.top-60,1000*speed);
                        Plumb.moveTo(info.id,posFim.left+125,posFim.top,1000*speed);
                    } else {
                        Plumb.moveTo(info.id,posFim.left,posFim.top,2000*speed);
                    }
                    setTimeout(function () {
                        highlighter.clear(450);
                        highlighter.lineRed(5,450);
                        if(leitor.prox!==null) {
                            highlighter.line(10,900);
                            if(leitor.ant===null){
                                highlighter.line(12,1350);
                                highlighter.lines(14,16,1600);
                                highlighter.clear(2000);
                            } else {
                                highlighter.lineRed(12,1350);
                                highlighter.line(18,1350);
                                highlighter.lines(20,23,1600);
                                highlighter.clear(2000);
                            }
                        } else {
                            highlighter.line(26,900);
                            highlighter.lineRed(10,900);
                            if(leitor.ant===null){
                                highlighter.line(28,1350);
                                highlighter.line(29,1600);
                                highlighter.clear(2000);
                            } else {
                                highlighter.lineRed(28,1350);
                                highlighter.line(30,1350);
                                highlighter.lines(32,33,1600);
                                highlighter.clear(2000);
                            }

                        }
                        deslocarApartir(leitor.prox,125,2000*speed);
                        setTimeout(function(){
                            if(leitor.ant===null)
                                setInitial(info.id,true);
                            if(leitor.prox===null)
                                setRightFinal(info.id,true);
                            connectDisc(leitor);
                            UI.unlock();
                            window.Eprogramada.nextQueue();
                        },2000*speed);
                    }, i * 2000 * speed);
                    break;
                } else if (leitor.prox!==null) {
                    posFim = {left: parseInt(leitor.dados.d.style.left), top: parseInt(leitor.dados.d.style.top)};
                    Plumb.moveTo(info.id,posFim.left,posFim.top - 60,2000*speed);
                }
                highlighter.line(5,looptime);
                highlighter.line(7,looptime+500);
                highlighter.line(8,looptime+1000);
                leitor = leitor.prox;
                i++;
            }
        } else {
            highlighter.clear(450);
            highlighter.lineRed(5,450);
            highlighter.line(26,900);
            highlighter.lineRed(10,900);
            highlighter.line(28,1350);
            highlighter.line(29,1600);
            highlighter.clear(2000);
            Plumb.moveTo(info.id,posFim.left,posFim.top,2000*speed);
            setTimeout(function(){
                setInitial(info.id,true);
                setRightFinal(info.id,true);
                UI.unlock();
                window.Eprogramada.nextQueue();
            },2000*speed);
        }
    },
    
    animationSearch = function (info) {
        UI.lock();
        var speed = getSpeed();
        var i = 0;
        var leitor = collection.cabeca;
        var pos = {left: -25, top: screen.height / 2.5};
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        highlighter.lines(0,1,50);
        while(leitor!==null) {
            var looptime = 2000*i + 1000;
            pos = {left:parseInt(leitor.dados.d.style.left),top:parseInt(leitor.dados.d.style.top) - 65};
            Plumb.moveTo(info.id,pos.left,pos.top,2000 * speed);
            if (info.valor*1 <= leitor.valor*1) {
                setTimeout(function () {
                    if (info.valor*1 === leitor.valor*1) {
                        foundAnimation(leitor.dados.id,1000*speed);
                    }
                }, (i+1) * 2000 * speed);
                break;
            }
            highlighter.line(2,looptime);
            highlighter.clear(looptime+500);
            highlighter.lineRed(4,looptime+500);
            highlighter.line(6,looptime+1000);
            i++;
            leitor = leitor.prox;
        }
        setTimeout(function () {
            if(leitor===null) {
                Plumb.moveTo(info.id, pos.left + 125, pos.top, 2000 * speed);
                highlighter.clear(500);
                highlighter.lineRed(2,500);
                highlighter.line(8,1000);
                highlighter.clear(2000);
            } else {
                if(info.valor*1 === leitor.valor*1){
                    highlighter.line(2,1000);
                    highlighter.line(4,2000);
                    highlighter.line(5,3000);
                    highlighter.clear(4000);
                } else {
                    highlighter.clear(500);
                    highlighter.lineRed(2,500);
                    highlighter.line(8,1000);
                    highlighter.clear(2000);
                }
            }
            
            setTimeout(function () {
                $("#" + info.id).fadeOut(1000 * speed);
                setTimeout(function () {
                    UI.unlock();
                    $("#" + info.id).remove();
                }, leitor===null || info.valor*1 !== leitor.valor*1?1000 * speed:6000 * speed);
            }, 2000 * speed);
        }, i * 2000 * speed);

    },
    
    animationRemove = function (info) {
        UI.lock();
        var speed = getSpeed();
        var i = 0;
        var leitor = collection.cabeca;
        var pos = {left: -25, top: screen.height / 2.5};
        var higlighter = new HighlighterAlgoritmo(VK.REMOCAO);
        higlighter.lines(0,1,50);
        while(leitor!==null) {
            var looptime = 2000*i + 1000;
            pos = {left:parseInt(leitor.dados.d.style.left),top:parseInt(leitor.dados.d.style.top) - 65};
            Plumb.moveTo(info.id,pos.left,pos.top,2000 * speed);
            if (info.valor*1 <= leitor.valor*1) {
                higlighter.clear(looptime);
                higlighter.lineRed(2,looptime);
                setTimeout(function () {
                    if (info.valor*1 === leitor.valor*1) {
                        higlighter.line(7,10);
                        foundAnimation(leitor.dados.id,1000*speed);
                        if(leitor.ant===null){
                            higlighter.line(9,1000);
                            if(leitor.prox!==null){
                                higlighter.line(11,2000);
                                higlighter.line(12,3000);
                                higlighter.line(13,4000);
                                higlighter.line(21,5000);
                                higlighter.clear(6000);
                            } else{
                                higlighter.clear(2000);
                                higlighter.lineRed(11,2000);
                                higlighter.line(13,3000);
                                higlighter.line(21,4000);
                                higlighter.clear(5000);
                            }
                        } else {
                            higlighter.line(15,1000);
                            higlighter.lineRed(9,1000);
                            higlighter.line(17,2000);
                            if(leitor.prox!==null) {
                                higlighter.line(18,3000);
                                higlighter.line(19,4000);
                                higlighter.line(21,5000);
                                higlighter.clear(6000);
                            } else {
                                higlighter.clear(3000);
                                higlighter.lineRed(18,3000);
                                higlighter.lineRed(21,4000);
                                higlighter.clear(5000);
                            }
                        }
                        
                        setTimeout(function(){
                            disconnectDisc(leitor);
                            if(leitor.ant!==null) {
                                leitor.ant.prox=leitor.prox;
                                if(leitor.prox===null)
                                    setRightFinal(leitor.ant.dados.id,true);
                                else
                                    leitor.prox.ant = leitor.ant;
                            } else {
                                collection.cabeca = collection.cabeca.prox;
              
                                if(collection.cabeca!==null) {
                                    setInitial(collection.cabeca.dados.id,true);
                                    collection.cabeca.ant = null;
                                }
                            }
                            deslocarApartir(leitor.prox,-125,2000*speed);
                        },6000*speed);
                    } else {
                        higlighter.clear(10);
                        higlighter.lineRed(7,10);
                    }
                }, (i+1) * 2000 * speed);
                break;
            }
            higlighter.line(2,looptime);
            higlighter.line(4,looptime+500);
            higlighter.line(5,looptime+1000);
            i++;
            leitor = leitor.prox;
        }
        setTimeout(function () {
            if(leitor===null){
                Plumb.moveTo(info.id, pos.left + 125, pos.top, 2000 * speed);
                higlighter.clear(10);
                higlighter.lineRed(2,10);
                higlighter.clear(1000);
                higlighter.lineRed(7,1000);
                higlighter.clear(2000);
            }
            setTimeout(function () {
                $("#" + info.id).fadeOut(1000 * speed);
                setTimeout(function () {
                    UI.unlock();
                    $("#" + info.id).remove();
                }, leitor===null || info.valor*1 !== leitor.valor*1?1000 * speed:6000 * speed);
            }, 2000 * speed);
        }, i * 2000 * speed);
    },
    prepareAnt = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{anchor:[1, 0.3, 0, -1],isSource:false,isTarget:true,isPrimary:true});
    },
    prepareProx = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{anchor:[0, 0.3, 0, -1],isSource:true,isTarget:false,isPrimary:true});
    },
    prepareAnt2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{anchor:[0, 0.7, 0, -1],isSource:false,isTarget:true,isPrimary:false});
    },
    prepareProx2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{anchor:[1, 0.7, 0, -1],isSource:true,isTarget:false,isPrimary:false});
    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicDot altColor",
            innerHTML:"<span class='itemValue altColorTitle'>" + value + "</span>",
            left:"100px",
            top:"75px",
            title:value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    },
    connectDisc = function (elem) {
        if(elem.ant!==null && elem.prox!==null) {
            Plumb.desconectar({source:elem.ant.dados.id,target:elem.prox.dados.id});
            Plumb.desconectar({target:elem.ant.dados.id,source:elem.prox.dados.id});
        }
        if(elem.ant!==null) {
            Plumb.conectar(prepareAnt(elem.ant.dados.id),prepareProx(elem.dados.id));
            Plumb.conectar(prepareAnt2(elem.dados.id),prepareProx2(elem.ant.dados.id));
        }
        if(elem.prox!==null) {
            Plumb.conectar(prepareAnt(elem.dados.id),prepareProx(elem.prox.dados.id));
            Plumb.conectar(prepareAnt2(elem.prox.dados.id),prepareProx2(elem.dados.id));
        }
    },
    disconnectDisc = function (raiz) {
        Plumb.desconectarCompletamente(raiz.dados.id);
        
        if(raiz.ant!==null && raiz.prox!==null)
        {
            Plumb.conectar(prepareAnt(raiz.ant.dados.id),prepareProx(raiz.prox.dados.id));
            Plumb.conectar(prepareAnt2(raiz.prox.dados.id),prepareProx2(raiz.ant.dados.id));
        }
    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.InitFunctions(this.addDisc,this.removeValue,this.searchValue);
            UI.setProperty("primaryColorProperty",true);
            UI.InitInterface(this.search,this.elementToString);
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        elementToString: function(id){
            var element = Element.get(id);
            if (element !== undefined) {
                var result = {'info': element.valor};
                if (element.prox !== null) {
                    var nextId = (element.prox.dados.id * 1).toString(16).toUpperCase();
                    result.proximo = '*' + (nextId.substring(nextId.length - 5));
                } else
                    result.proximo = 'null';
                if (element.ant !== null) {
                    var nextId = (element.ant.dados.id * 1).toString(16).toUpperCase();
                    result.anterior = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.anterior = 'null';
                return result;
            }
            return false;
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value('valor',"Entrada deve ser um número");
                if (value !== "") {
                    var info = createDisc(value);
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    collection.insere(value, info);
                    Plumb.tornarArrastavel(info.id);
                    animationAdd(info);
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {

            var value = UI.value('valor',"Entrada deve ser um número");
            
            if (value !== "") {
                UI.subtitle("Removendo o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationRemove(info);
            }

        },
        searchValue: function () {
            var value = UI.value('valor',"Entrada deve ser um número");
            
            if (value !== "") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationSearch(info);
            }
        }

    };
})();