jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function ListaSimplesOrdenada() {
    this.cabeca = null;

    ListaSimplesOrdenada.criaNo = function () {
        return {
            dados: null,
            valor: null,
            prox: null
        };
    };

    this.insere = function (valor, dado) {
        var novo = ListaSimplesOrdenada.criaNo();
        novo.dados = dado;
        novo.valor = valor;
        Element.bind(novo,dado.id);
        var ant = null;
        var aux = this.cabeca;

        while (aux != null && aux.valor * 1 < valor * 1) {
            ant = aux;
            aux = aux.prox;
        }
        if (aux != null) {
            if (ant == null) {
                novo.prox = this.cabeca;
                this.cabeca = novo;
            } else {
                ant.prox = novo;
                novo.prox = aux;
            }
        } else {
            if (ant == null) {
                this.cabeca = novo;
            } else {
                ant.prox = novo;
            }
        }
    };
}

(function () {
    var collection = new ListaSimplesOrdenada();
    var 
    setInitial = function(elId,key){
        $("span.initial").remove();
        if(key) {
            $("#"+elId).append("<span class='initial'>Lista</span>");
        }
    },
    setFinal = function(elId,key){
        $("span.final").remove();
        if(key) {
            $("#"+elId).append("<span class='final'>null</span>");
        }
    },
    deslocar = function (dados, offsetX, tempo) {
        Plumb.moveTo(dados.id, parseInt(dados.d.style.left) + offsetX,parseInt(dados.d.style.top), tempo);
    },
    deslocarApartir = function (raiz, offsetX, tempo) {
        while(raiz!==null) {
            deslocar(raiz.dados,offsetX,tempo);
            raiz = raiz.prox;
        }
    },
    foundAnimation = function(id,speed){
        var obj = $("#" + id);
        obj.fadeOut(speed);
        obj.fadeIn(speed);
        obj.fadeOut(speed);
        obj.fadeIn(speed);
        obj.fadeOut(speed);
        obj.fadeIn(speed);
    },
    animationAdd = function (info) {
        UI.lock();

        var posFim = {left: 100, top: screen.height / 2.5};
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        highlighter.lines(0,3,10);
            
        if (collection.cabeca.prox!==null) {
            var ant = null;
            var i=0;
            var leitor = collection.cabeca;
            while(leitor!==null) {
                var looptime = 2000*i + 1000;
                if(info.valor*1===leitor.valor*1) {
                    if(ant!==null) {
                        Plumb.moveTo(info.id,posFim.left+125,posFim.top,2000*speed);
                    } else {
                        Plumb.moveTo(info.id,posFim.left,posFim.top,2000*speed);
                    }
                    setTimeout(function () {
                        deslocarApartir(leitor.prox,125,2000*speed);
                        highlighter.lineRed(4,1000);
                        if (leitor.prox === null) {
                            highlighter.lineRed(9,1500);
                            highlighter.line(22,1500);
                            if(ant===null) {
                                highlighter.line(24,2000);
                                highlighter.line(25,2500);
                            } else {
                                highlighter.lineRed(24,2000);
                                highlighter.line(26,2000);
                                highlighter.line(27,2500);
                            }
                            highlighter.clear(3000);
                        } else {
                            highlighter.line(9,1500);
                            if(ant===null) {
                                highlighter.line(11,2000);
                                highlighter.line(13,2500);
                                highlighter.line(14,3000);
                            } else {
                                highlighter.line(16,2000);
                                highlighter.lineRed(11,2000);
                                highlighter.line(18,2500);
                                highlighter.line(19,3000);
                            }
                            highlighter.clear(3500);
                        }
                        setTimeout(function () {
                            if (ant === null)
                                setInitial(info.id, true);
                            if(leitor.prox===null)
                                setFinal(info.id, true);
                            Plumb.tornarArrastavel(info.id);
                            connectDisc(ant, leitor);
                            UI.unlock();
                            window.Eprogramada.nextQueue(); 
                        },2000*speed);
                    }, i * 2000 * speed);
                    break;
                } else if (leitor.prox!==null) {
                    posFim = {left: parseInt(leitor.dados.d.style.left), top: parseInt(leitor.dados.d.style.top)};
                    Plumb.moveTo(info.id,posFim.left,posFim.top - 60,2000*speed);
                }
                highlighter.line(4,looptime);
                highlighter.line(6,looptime+600);
                highlighter.line(7,looptime+1200);
                ant = leitor;
                leitor = leitor.prox;
                i++;
            }
        } else {
            highlighter.lineRed(4,1500);
            highlighter.clear(2000);
            highlighter.line(22,2000);
            highlighter.lineRed(9,2000);
            highlighter.line(24,2500);
            highlighter.line(25,3000);
            highlighter.clear(4000);
            Plumb.moveTo(info.id,posFim.left,posFim.top,2000*speed);
            setTimeout(function(){
                setInitial(info.id,true);
                setFinal(info.id,true);
                Plumb.tornarArrastavel(info.id);
                UI.unlock();
                window.Eprogramada.nextQueue();
            },4000*speed);
        }
    },
    
    animationSearch = function (info) {
        UI.lock();
        var speed = getSpeed();
        var i = 0;
        var leitor = collection.cabeca;
        var pos = {left: -25, top: screen.height / 2.5};
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        highlighter.lines(0,1,10);

        while(leitor!==null) {
            var looptime = 2000*i+1000;
            pos = {left:parseInt(leitor.dados.d.style.left),top:parseInt(leitor.dados.d.style.top) - 65};
            Plumb.moveTo(info.id,pos.left,pos.top,2000 * speed);
            if (info.valor*1 <= leitor.valor*1) {
                setTimeout(function () {
                    if (info.valor*1 === leitor.valor*1) {
                        highlighter.line(2,10);
                        highlighter.line(4,1000);
                        highlighter.line(5,2000);
                        highlighter.clear(3000);
                        foundAnimation(leitor.dados.id,1000*speed);
                    } else{
                        highlighter.clear(10);
                        highlighter.lineRed(2,10);
                        highlighter.line(8,1000);
                        highlighter.clear(2000);
                    }
                }, (i+1) * 2000 * speed);
                break;
            }
            highlighter.line(2,looptime);
            highlighter.clear(looptime+500);
            highlighter.lineRed(4,looptime+500);
            highlighter.line(6,looptime+1000);
            i++;
            leitor = leitor.prox;
        }
        setTimeout(function () {
            if(leitor===null){
                Plumb.moveTo(info.id, pos.left + 125, pos.top, 2000 * speed);
                highlighter.clear(1000);
                highlighter.lineRed(2,1000);
                highlighter.line(8,1500);
                highlighter.clear(2000);
            }
            setTimeout(function () {
                $("#" + info.id).fadeOut(1000 * speed);
                setTimeout(function () {
                    UI.unlock();
                    $("#" + info.id).remove();
                }, leitor===null || info.valor*1 !== leitor.valor*1?1000 * speed:6000 * speed);
            }, 2000 * speed);
        }, i * 2000 * speed);

    },
    
    animationRemove = function (info) {
        UI.lock();
        var speed = getSpeed();
        var i = 0;
        var leitor = collection.cabeca;
        var pos = {left: -25, top: screen.height / 2.5};
        var ant=null;
        var highlighter = new HighlighterAlgoritmo(VK.REMOCAO);
        highlighter.lines(0,1,50);
        while(leitor!==null) {
            var looptime = 2000*(i+1);
            pos = {left:parseInt(leitor.dados.d.style.left),top:parseInt(leitor.dados.d.style.top) - 65};
            Plumb.moveTo(info.id,pos.left,pos.top,2000 * speed);
            if (info.valor*1 <= leitor.valor*1) {
                setTimeout(function () {
                    if(info.valor*1 === leitor.valor*1){
                        highlighter.line(7,1000);
                        highlighter.lineRed(2,100);
                        if(ant===null){
                            highlighter.line(9,2000);
                            highlighter.line(10,3000);
                        } else {
                            highlighter.line(11,2000);
                            highlighter.lineRed(9,2000);
                            highlighter.line(12,3000);                            
                        }
                        highlighter.line(13,4000);
                        highlighter.clear(5000);
                        
                        foundAnimation(leitor.dados.id,1000*speed);
                        setTimeout(function(){
                            disconnectDisc(ant,leitor);
                            //collection.remove abaixo
                            if(ant!==null) {
                                ant.prox=leitor.prox;
                                if(leitor.prox===null)
                                    setFinal(ant.dados.id,true);
                            } else {
                                collection.cabeca = collection.cabeca.prox;
                                if(collection.cabeca!==null)
                                    setInitial(collection.cabeca.dados.id,true);
                            }
                            deslocarApartir(leitor.prox,-125,2000*speed);

                        },6000*speed);
                    } else {
                        highlighter.lineRed(2,100);
                        highlighter.clear(1000);
                        highlighter.lineRed(7,1000);
                        highlighter.clear(2000);
  
                    }
                }, (i+1) * 2000 * speed);
                break;
            }
            highlighter.line(2,looptime);
            highlighter.line(4,looptime+600);
            highlighter.line(5,looptime+1200);
            i++;
            ant = leitor;
            leitor = leitor.prox;
        }
        setTimeout(function () {
            if(leitor===null){
                Plumb.moveTo(info.id, pos.left + 125, pos.top, 2000 * speed);
                highlighter.clear(2000);
                highlighter.lineRed(2,2000);
                highlighter.clear(3000);
                highlighter.lineRed(7,3000);
                highlighter.clear(4000);
            }
            setTimeout(function () {
                highlighter.clear(0);
                $("#" + info.id).fadeOut(1000 * speed);
                setTimeout(function () {
                    UI.unlock();
                    $("#" + info.id).remove();
                }, leitor===null || info.valor*1 !== leitor.valor*1?1000 * speed:6000 * speed);
            }, 2000 * speed);
        }, i * 2000 * speed);
    },
    prepareAnt = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{anchor:"Right",isSource:false,isTarget:true,isPrimary:true});
    },
    prepareProx = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{anchor:"Left",isSource:true,isTarget:false,isPrimary:true});
    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicDot altColor",
            innerHTML:"<span class='itemValue altColorTitle'>" + value + "</span>",
            left:"100px",
            top:"75px",
            title:value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    },
    connectDisc = function (ant,elem) {
        if(ant!==null && elem.prox!==null) {
            Plumb.desconectar({source:ant.dados.id,target:elem.prox.dados.id});
        }
        if(ant!==null) {
            Plumb.conectar(prepareAnt(ant.dados.id),prepareProx(elem.dados.id));
        }
        if(elem.prox!==null) {
            Plumb.conectar(prepareAnt(elem.dados.id),prepareProx(elem.prox.dados.id));
        }
    },
    disconnectDisc = function (ant,raiz) {
        Plumb.desconectarCompletamente(raiz.dados.id);
        
        if(ant!==null && raiz.prox!==null)
            Plumb.conectar(prepareAnt(ant.dados.id),prepareProx(raiz.prox.dados.id));
    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.setProperty("primaryColorProperty",true);
            UI.InitFunctions(this.addDisc,this.removeValue,this.searchValue);
            UI.InitInterface(this.search,this.elementToString);
        },
        elementToString: function(id){
            var element = Element.get(id);
            if (element !== undefined) {
                var result = {'info': element.valor};
                if (element.prox !== null) {
                    var nextId = (element.prox.dados.id * 1).toString(16).toUpperCase();
                    result.proximo = '*' + (nextId.substring(nextId.length - 5));
                } else
                    result.proximo = 'null';
                return result;
            }
            return false;
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value('valor',"O Valor deve ser um número");
                if (value !== "") {
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    var info = createDisc(value);
                    collection.insere(value, info);
                    animationAdd(info);
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {

            var value = UI.value('valor',"O Valor deve ser um número");
    
            if (value !== "") {
                UI.subtitle("Removendo o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationRemove(info);
            }

        },
        searchValue: function () {

            var value = UI.value('valor',"O Valor deve ser um número");
            
            if (value !== "") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationSearch(info);
            }
        }

    };

})();