function Color2Pseudo(innerHtml){
    innerHtml=innerHtml.replace(/[-|/|+|*|%|.]/g, function (match) {
        return "<g>" + match + "</g>";
    });
    innerHtml=innerHtml.replace(":=","<g>:=</g>");
    innerHtml=innerHtml.replace("!=","<g>!=</g>");
    innerHtml=innerHtml.replace("==","<g>==</g>");
    innerHtml=innerHtml.replace(" = ","<g> = </g>");
    innerHtml=innerHtml.replace(" : "," <g>:</g> ");

    innerHtml=innerHtml.replace(/(Break|Retornar|Senão|Se |Enquanto |então|Para |até |passo |faça| de |se )/g, function (match) {
        return "<b>" + match + "</b>";
    });
    innerHtml=innerHtml.replace(/([a-z|A-Z|_][a-z|A-Z|_|0-9]*)?[(]/g, function (match) {
        return "<b>" + match + "</b>";
    });
    innerHtml=innerHtml.replace(/(Estrutura[a-zA-Z_]*|booleano|inteiro|caracter|array)/g, function (match) {
        return "<struct>" + match + "</struct>";
    });
    innerHtml=innerHtml.replaceAll(" &gt; "," <g> &gt </g>");
    innerHtml=innerHtml.replaceAll(" &lt; "," <g> &lt </g>");
    innerHtml=innerHtml.replaceAll(" &gt;= ","<g> &gt= </g>");
    innerHtml=innerHtml.replaceAll(" &lt;= ","<g> &lt= </g>");
    innerHtml=innerHtml.replaceAll(" e ","<g> e </g>");
    innerHtml=innerHtml.replaceAll(" ou ","<g> ou </g>");
    innerHtml=innerHtml.replace("Verdadeiro","<d>Verdadeiro</d>");
    innerHtml=innerHtml.replace("Falso","<e>Falso</e>");
    innerHtml=innerHtml.replace("nulo","<e>nulo</e>");
    
    innerHtml=innerHtml.replaceAll(",","<b>,</b>");
    innerHtml=innerHtml.replaceAll(")","<b>)</b>");
    innerHtml=innerHtml.replaceAll("[","<e>[</e>");
    innerHtml=innerHtml.replaceAll("]","<e>]</e>");
    innerHtml=innerHtml.replace(/(INICIO|FIM)/, function (match) {
        return "<c>" + match + "</c>";
    });
    return innerHtml;
}

function strip(html) {
   var tmp = document.createElement("div");
   tmp.innerHTML = html;
   return tmp.textContent||tmp.innerText;
}