<?PHP

session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    echo 'erro: sessão fechada';
    return;
}
include './config/Database.php';
include './controladores/ControladorUsuario.php';
include './controladores/Professor.php';
include './controladores/Turma.php';
include './entidades/Atividade.php';
$email = $_SESSION['email'];

$controlador = new ControladorUsuario();
if (!$controlador->setUser($email)) {
    echo 'erro: usuário não encontrado';
    return;
}

if (!$controlador->ehAluno()) {
    $controlador = $controlador->getProfessor();


    if (!isset($_POST['titulo']) || !isset($_POST['detalhes']) || !isset($_FILES['arquivo']) || !isset($_POST['index'])) {
        echo 'erro: alguns dos parametros não foram encontrados';
        $a = $_POST['titulo'];
        $b = $_FILES['arquivo'];
        $c = $_POST['index'];
        $d = $_POST['detalhes'];
        return;
    }

    $index = (int) $_POST['index'];
    $titulo = strip_tags($_POST['titulo']);
    $detalhes = preg_replace("/<([a-z][a-z0-9]*)[^>]*?(\/?)>/i", '<$1$2>', strip_tags($_POST['detalhes'], '<b><i><big><small><center><h1><h2><h3><h4><h5><h6>'));
    $turma = $controlador->getTurmaByIndex($index);

    $file = $_FILES['arquivo'];
    if (!$turma) {
        echo 'Turma não encontrada';
        return;
    }

    if (!$turma->novoMaterialDidatico($titulo, $detalhes, $file)) {
        echo 'erro no banco';
        return;
    }
    header('location: ./materiaisdidaticosedit.php?index=' . $index);
} else {
    echo 'erro: usuário não é um professor';
}
